/*-----------------------------------------------------------------------
| wcom.cpp - Windows Communications, Test TTY screens.

 This program is a 32-bit MDI(Multiple Document Interface)
 communications program, each MDI child is a terminal for a port.

 The program has several goals:
 * example to demonstrate communications coding in Win32 environment.

 * Serve as a general purpose testing vehicle for communication drivers.

8-18-98 - Add temporary fix for Windows98 fault on stock com-ports
  on open.  IdentifyPort() custom EscapeComm params were causing
  a fault.
8-10-98 - Fix ReadPort bug which could cause Wcom to fault.
5-27-98 - drop 16-bit compilation, start ripping out old 16-bit code.
5-26-98 - added caret, use ttywin.cpp.
4-08-98 - add pnp_modem_id detect test.
4-01-98 - fix buildcomm command line option stuff.
9-15-97 V1.38 - add ring indicator support.
9-04-97 V1.37 - don't try rts override by button press for nt
  if automatic flow is on(nt doesn't let you do this.)
8-13-97 V1.36 - Add menu selection to override into RS485 toggle-low
  mode for RS485 product support.  Clean up WIN32 warnings.
7-08-97 V1.35 - bump up timer rate to 25ms, so program can obtain
  above 115K bps.
7-01-97 V1.34 - add holding reason button feedback(2nd set of lights
   showing holding reasons.
6-23-97 V1.33 - if qsizes dialog screen up, then stop reading/writting
  to port.  This provides a way to test flow control.
6-05-97 V1.32 - add version tracking, add loopback test.
5-28-97 add 921600 baud rate selection.
3-26-97 take away loopback button for non-comtrol ports.
3-5-97 add ability to do purges, set/clear break.
10-21-96 add clear-screen, cr/lf option, send-xoff, send-xon.
5-24-96  Add buttons, use timer,
1-05-96  Work on displaying modem status.
10-31-95  Made data scroll properly in window.  Fixed Dialogs.
   Added optional commrkt.h usage.
10-09-95 create dialog boxes, clean up - kpb

Copyright 1995,96,97,98 Comtrol(TM) Corporation.
|-----------------------------------------------------------------------*/
/*** #include <windowsx.h> ***/
#define STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <string.h>
#include "wcomr.h"
#include "ttywin.h"
#include "wcom.h"

#define WIN98_TEMP_FIX

#define PKT_WRITE_SIZE 5000

// #define SHOW_CLOCK 1

BOOL FAR PASCAL CloseEnumProc (HWND, LONG) ;
LRESULT FAR PASCAL MainWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT FAR PASCAL WcomWndProc(HWND, UINT, WPARAM, LPARAM);

static void SetSettingsDlgInfo(HWND hDlg);
static void GetSettingsDlgInfo(HWND hDlg);
BOOL FAR PASCAL settings_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam);

BOOL FAR PASCAL portname_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam);

BOOL FAR PASCAL qsizes_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam);

static void SetMiscDlgInfo(HWND hDlg);
static void GetMiscDlgInfo(HWND hDlg);
BOOL FAR PASCAL misc_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam);

static void SetPortDlgInfo(HWND hDlg);
static void GetPortDlgInfo(HWND hDlg);
BOOL FAR PASCAL options_dlg_proc(HWND hDlg, UINT message,
                                 WPARAM wParam, LPARAM lParam);

BOOL FAR PASCAL timeouts_dlg_proc(HWND hDlg, UINT message,
                                 WPARAM wParam, LPARAM lParam);

void init_events_buttons(HWND hDlg,
                         DWORD ev,
                         int rec_cnt, int send_cnt);

BOOL FAR PASCAL events_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam);

BOOL FAR PASCAL enter_int_dlg_proc(HWND hDlg, UINT message,
                                 WPARAM wParam, LPARAM lParam);

static int GetDlgItemNumb(HWND hDlg, int ctrl, unsigned long *num);
void poll_ports(void);
static void draw_light(HDC hdc, int on, int index, int flags);
static void draw_hold_light(HDC hdc, int index, int flags);
static int IsWindows98(void);
int SetToggleLow(HANDLE hCom, int on);
int CreatePortWin(int auto_size);
void im_mess1(char *str1, int i1,
              char *str2, int i2);

// modem status register defs
#define ACE_CTS  0x10  //  Clear To Send
#define ACE_DSR  0x20  // Data Set ready
#define ACE_RI   0x40  // Ring Indicator
#define ACE_RLSD 0x80  // Receive Line Signal Detect

// have to track output pins ourselves
#define MY_DTR      0x01
#define MY_RTS      0x02
#define MY_LOOPBACK 0x04
/*--------------------------  Global Variables  ---------------------*/
HINSTANCE glob_hinst = 0;      // current instance

// need to make these available in the program menu or dialog.
int   msr_cheat = 1;
//int event_cheat = 0;
int show_status = 1;

int frame_width;
int frame_height;
char gtmpstr[160];
HMENU  hMenuMain;

WCom *head_wcom = NULL; // head of list of active port windows

/*----------------------- local vars ---------------------------------*/
HMENU  hMenuMainWindow;

HWND  hwndDraw   = 0;
HWND  hwndFrame  = 0;
HWND  hwndClient = 0;

static int int_val;
static long long_val;

static HGLOBAL hmem_glob = 0;
static char far *mem_glob = 0;

WCom *glob_wcom = NULL;  // used when opening port windows
WCom *glob_dlg_wcom = NULL;

int save_to_disk = 0;
int show_crlf = 0;
char default_str[60];
int send_mess_flag = 0;

unsigned char test_str[PKT_READ_SIZE+100];
int test_str_len = 0;
DWORD PlatformId;

char *hold_buttons[] = {"CTS", "DSR", "CD",  "XOFFH", "XOFFS", "EOF", "TXIM", NULL};
int hold_buttons_x[8];
int hold_buttons_size[8];

char *buttons[] = {"CTS", "DSR", "CD",  "RI", "RTS", "DTR", "LOOP", NULL};
int buttons_x[8];
int buttons_size[8];
WORD last_port_menu;
char pickportname[42];
int start_port_create_flag = 0;  // used to cause WM_SIZE to create a port win

static char *apname = {"Wcom - Test Terminal"};

static char *copyright = {"Copyright (c) 1996-98 Comtrol Corp."};

/*------------------------------------------------------------------------
| WinMain -
|------------------------------------------------------------------------*/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow)
{
   HACCEL  hAccel;
   MSG      msg;
   WNDCLASS  wc;
   DWORD old_ms_time = 0;
   char *buf;

   int i, j, lastx;

   glob_hinst = hInstance;

   pickportname[0] = 0;

           // calculate the button sizes and positions
   i = 0;
   lastx = 5;
   while (buttons[i] != NULL)
   {
     buttons_x[i] = lastx;
     buttons_size[i] = strlen(buttons[i]) * 10;
     lastx += buttons_size[i] + 2;
     if ((i==3) || (i==6))
       lastx += 5;  // offset over
     ++i;
   }

   // calculate the holding status button sizes and positions
   i = 0;
   lastx = 60;
   while (hold_buttons[i] != NULL)
   {
     hold_buttons_x[i] = lastx;
     hold_buttons_size[i] = strlen(hold_buttons[i]) * 10;
     lastx += hold_buttons_size[i] + 2;
     ++i;
   }

   if (!hPrevInstance)	// Other instances of app running?
   {
     // FRAME WINDOW
     wc.style       = CS_HREDRAW | CS_VREDRAW;	// Class style(s).
     wc.lpfnWndProc = MainWndProc;
     wc.cbClsExtra  = 0;	// No per-class extra data.
     wc.cbWndExtra  = 0;	// No per-window extra data.
     wc.hInstance   = hInstance;	// Application that owns the class.
     wc.hIcon       = LoadIcon(hInstance, "wcom1");
     wc.hCursor     = LoadCursor(NULL, IDC_ARROW);
     wc.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1);
     wc.lpszMenuName  = NULL;  // Name of menu resource in .RC file.
     wc.lpszClassName = "WcomFrame";	// Name used in call to CreateWindow.
     RegisterClass(&wc);

     // Draw WINDOW
     wc.style       = CS_HREDRAW | CS_VREDRAW | CS_OWNDC; // Class style(s).
     wc.lpfnWndProc = WcomWndProc;
     wc.cbClsExtra  = 0;	// No per-class extra data.
     wc.cbWndExtra  = sizeof(void *);
     wc.hInstance   = hInstance;	// Application that owns the class.
     wc.hIcon       = LoadIcon(hInstance, "wcom1");
     wc.hCursor     = LoadCursor(NULL, IDC_ARROW);
     wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
     wc.lpszMenuName  = NULL;	// Name of menu resource in .RC file.
     wc.lpszClassName = "WcomDraw";	// Name used in call to CreateWindow.
     RegisterClass(&wc);
   }
  /* Perform initializations that apply to a specific instance */

   // following is a buildcomm() string which can be used to init the ports
   // format: "9600,n,8,1"
   default_str[0] = 0;

  buf = lpCmdLine;
  i=0;
  while ((*buf != 0) && (i < 80))
  {
    if ((*buf == '-') || (*buf == '/'))
    {
      ++buf;
      ++i;
      switch(toupper(*buf++))
      {
        //case 'T':  // test mode, run only to test ui
        //  test_mode = 1;
        //break;

        case '?':  // our help
         MessageBox(GetFocus(),
"example>WCOM {COMNAME} {BUILDCOMM PARAMS}\n \
   COMNAME - com port name\n \
   BUILDCOMM PARAMS - BuildCommDCB() parameters\n \
 example>WCOM COM5 9600,n,8,1\n",
  apname,
 MB_OK);
        return 0;

        break;
      }  // switch
      ++buf;
    }  // if (option)
    else if (*buf != ' ')
    {
      if ((*buf < '0') || (*buf > '9'))
      {
        if (pickportname[0] == 0)
        {
          // must be a com -port name
          start_port_create_flag = 1;  // cause WM_SIZE to create a port win
          j = 0;
          while ((*buf != 0) && (*buf != ' ') && (*buf != ','))
          {
            pickportname[j++] = *buf++;
          }
          pickportname[j] = 0;
          //MessageBox(GetFocus(),"Port",pickportname,MB_OK);
        }
        else
          ++buf;
      }
      else  // a name
      {
        if (default_str[0] == 0)
        {
          j = 0;
          while ((*buf != 0) && (*buf != ' '))
          {
            default_str[j++] = *buf++;
          }
          default_str[j] = 0;
          //MessageBox(GetFocus(),"Using buildcommdcb.",default_str,MB_OK);
        }
        else
          ++buf;
      }
    }  // not a '-' option
    else
      ++buf;
   ++i;
  }  // while options

           // Obtain handles to 1 possible menus & submenus
   hMenuMain = LoadMenu (glob_hinst, "WCOMAPMENU");

   hMenuMainWindow = GetSubMenu (hMenuMain, 0);

   hAccel = LoadAccelerators (glob_hinst, "WcomAccel") ;

  OSVERSIONINFO os;  // about 150 bytes big

  os.dwOSVersionInfoSize = sizeof(os);
  if (FALSE == GetVersionEx(&os))  // nt or win95 or win32s
  {
    // mess("Platform Detect Fail: %d, [%dH]", PlatformId, PlatformId);
    PlatformId = VER_PLATFORM_WIN32_NT;
  }
  else
    PlatformId = os.dwPlatformId;

        // Create the frame window
	/* Create a main window for this application instance.  */
   hwndFrame = CreateWindow(
		"WcomFrame", 	               // See RegisterClass() call.
                                          // Text for window title bar.
                 apname,
		 WS_OVERLAPPEDWINDOW,    // Window style.
		 CW_USEDEFAULT, CW_USEDEFAULT, // Def. horz, vert pos.
                 CW_USEDEFAULT, CW_USEDEFAULT, // Default width, height
                 NULL,      // No Parent Window
                 hMenuMain,     // Use the window class menu.
                 hInstance, // This instance owns this window.
                 NULL);     // Pointer not needed.

   hwndClient = GetWindow (hwndFrame, GW_CHILD) ;

   hMenuMainWindow = GetSubMenu (hMenuMain, 0);

   ShowWindow (hwndFrame, nCmdShow) ;
   UpdateWindow (hwndFrame) ;

   while (GetMessage (&msg, NULL, 0, 0))
   {
     if (!TranslateMDISysAccel (hwndClient, &msg) &&
         !TranslateAccelerator (hwndFrame, hAccel, &msg))
     {
       TranslateMessage (&msg) ;
       DispatchMessage (&msg) ;
     }
   }
   return msg.wParam;
}

/*------------------------------------------------------------------------
| poll_ports - this is a polling routine which checks for activity
   on comm-ports, and services them when needed.
|------------------------------------------------------------------------*/
void poll_ports(void)
{
  WCom *wcom = head_wcom;


             // do com port polling every so often
  while (wcom != NULL)
  {
    ++wcom->ticks;
    wcom->check_com_port();

    if ((wcom->old_msr_status != wcom->msr_status) ||
        (wcom->old_mcr_status != wcom->mcr_status))
      wcom->lights_update_flag = 1;

    if (wcom->lights_update_flag)  // need to update the screen.
    {
      wcom->update_lights(0);  // update changes to screen
      wcom->lights_update_flag = 0;
    }

    wcom->ttywin.update_screen(0);  // update changes to screen

    wcom = wcom->next_wcom;
  }
}

/*------------------------------------------------------------------------
| MainWndProc - MDI Frame Proc.
|------------------------------------------------------------------------*/
LRESULT FAR PASCAL MainWndProc(HWND hwnd, UINT message,
						WPARAM wParam, LPARAM lParam)
{
// DLGPROC         DlgProcPtr; /* pointer to the setup_scr function */
 FARPROC lpProc; /* pointer to the setup_scr function */
 CLIENTCREATESTRUCT clientcreate ;
 FARPROC            lpfnEnum;
 HWND               hwndChild;
 HMENU hmenu_temp;
 HMENU hmenu_new;
 int i,k;

 UINT menu_flags;
 char tmpstr[20];

  switch (message)
  {
    case WM_CREATE: // Initialize Global vars
      
      hmenu_temp = GetSubMenu (hMenuMain, 0); // File
      hmenu_new = CreatePopupMenu();

      InsertMenu(hmenu_temp, 0,MF_POPUP | MF_BYPOSITION,
                 (WORD)hmenu_new, "&Open Port...");

      k=39;
      for (i=0; i<k; i++) 
      {
        menu_flags = 0;
        wsprintf(tmpstr,"COM%d",i+1);
                                              /* every 8th start a new col */
        if (((i % 10) == 0) && (i!=0)) menu_flags |= MF_MENUBREAK;
        AppendMenu(hmenu_new,  menu_flags, IDM_PORT_FIRST+i, tmpstr);
      }
      last_port_menu = IDM_PORT_FIRST+k;
      AppendMenu(hmenu_new,  menu_flags, last_port_menu, "Other");

         // disable settings menu
      EnableMenuItem(hMenuMain,1,MF_BYPOSITION | MF_DISABLED);
         // disable windows menu
      EnableMenuItem(hMenuMain,2,MF_BYPOSITION | MF_DISABLED);

      clientcreate.hWindowMenu  = hMenuMainWindow;
      clientcreate.idFirstChild = IDM_FIRSTCHILD;
      hwndClient = CreateWindow ("MDICLIENT", NULL,
                       WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
                       0, 0, 0, 0, hwnd, (HMENU) 0,  glob_hinst,
                       (LPSTR) &clientcreate);

      SetTimer(hwnd, 0, 25, NULL); // setup 25ms sec timer
    return NULL;
  
    case WM_TIMER:
      poll_ports();
    break;

    case WM_COMMAND:	// message: command from application menu

      if ((wParam >= IDM_PORT_FIRST) && (wParam < IDM_PORT_LAST))
      {
        if (wParam == last_port_menu)
        {
          lpProc = MakeProcInstance((FARPROC)portname_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "PORTNAMEDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
          if (pickportname[0] == 0)
            return 0;
        }
        else
          wsprintf(pickportname,"COM%d", (wParam - IDM_PORT_FIRST) + 1);

        CreatePortWin(1);
        return 0;
      }

      switch(wParam)
      {
       case IDM_CLOSE:          // Close the active window
   
         hwndChild = (HWND) (SendMessage (hwndClient,
                                          WM_MDIGETACTIVE,(WPARAM) 0, (LPARAM)0L)) ;
   
         if (SendMessage (hwndChild, WM_QUERYENDSESSION, (WPARAM) 0, (LPARAM) 0L))
                          SendMessage (hwndClient, WM_MDIDESTROY,
                                       (WPARAM)hwndChild, (LPARAM)0L) ;
       return 0;

       case IDM_SHOWCRLF:
         show_crlf ^= 1;
         if (show_crlf)
           CheckMenuItem (hMenuMain,IDM_SHOWCRLF,  MF_CHECKED);
         else
           CheckMenuItem (hMenuMain,IDM_SHOWCRLF,  MF_UNCHECKED);

         {
           WCom *wcom = head_wcom;
           while (wcom != NULL)
           {
             wcom->ttywin.show_crlf = show_crlf;
             wcom = wcom->next_wcom;
           }
         }

       return 0;

       case IDM_SAVEDISK:
         save_to_disk ^= 1;
         if (save_to_disk)
           CheckMenuItem (hMenuMain,IDM_SAVEDISK,  MF_CHECKED);
         else
           CheckMenuItem (hMenuMain,IDM_SAVEDISK,  MF_UNCHECKED);
       return 0;

       case IDM_SENDMESS:
         send_mess_flag ^= 1;
         if (send_mess_flag)
           CheckMenuItem (hMenuMain,IDM_SENDMESS,  MF_CHECKED);
         else
           CheckMenuItem (hMenuMain,IDM_SENDMESS,  MF_UNCHECKED);
       return 0;

                            // Messages for arranging windows
       case IDM_TILE:
         SendMessage (hwndClient, WM_MDITILE, (WPARAM)0, (LPARAM)0L) ;
       return 0;
   
       case IDM_CASCADE:
         SendMessage (hwndClient, WM_MDICASCADE, (WPARAM)0, (LPARAM)0L) ;
       return 0;
   
       case IDM_ARRANGE:
           SendMessage (hwndClient, WM_MDIICONARRANGE, (WPARAM)0, (LPARAM)0L) ;
       return 0;
   
       case IDM_CLOSEALL:       // Attempt to close all children
   
         lpfnEnum = MakeProcInstance ((FARPROC)CloseEnumProc, glob_hinst) ;
         EnumChildWindows (hwndClient, (WNDENUMPROC) lpfnEnum, (LPARAM)0L) ;
         FreeProcInstance (lpfnEnum) ;
       return 0;
   
        case IDM_HELP:
          WinHelp(hwnd,"WCOM.HLP",HELP_INDEX,0L);
        break;

        case IDM_HELPABOUT:
          wsprintf(gtmpstr, 
"Windows Test Terminal Version %s\nCopyright (c) 1996-98.",
                   VERSION_STRING);
          MessageBox(hwnd, gtmpstr, "About Wcom",MB_OK);
        return 0;

       default:            // Pass to active child
         hwndChild = (HWND) (SendMessage (hwndClient,
                               WM_MDIGETACTIVE, (WPARAM)0, (LPARAM)0L));
         if (IsWindow (hwndChild))
              SendMessage (hwndChild, WM_COMMAND, wParam, lParam);
       break;
     }
    break;

    case WM_QUERYENDSESSION:
    case WM_CLOSE:       // Attempt to close all children
      SendMessage (hwnd, WM_COMMAND, (WPARAM)IDM_CLOSEALL, (LPARAM)0L) ;
      if (NULL != GetWindow (hwndClient, GW_CHILD))
         DestroyWindow(hwnd);
    break ;   // ie, call DefFrameProc ;

    case WM_SIZE:
      frame_width = LOWORD(lParam);
      frame_height = HIWORD(lParam);
      // automatically open a port from command line params
      if (start_port_create_flag != 0)
      {
        start_port_create_flag = 0;
        if (pickportname[0] != 0)  
        {
          CreatePortWin(0);
        }
      }
    break; // have to let default have this too!

    case WM_QUIT:
    case WM_DESTROY:  // message: window being destroyed
      PostQuitMessage(0);
    return 0 ;
  }
  return DefFrameProc (hwnd, hwndClient, message, wParam, lParam) ;
}

/*-------------------------------------------------------------------
| CreatePortWin -
|--------------------------------------------------------------------*/
int CreatePortWin(int auto_size)
{
 MDICREATESTRUCT    mdicreate;
 int stat;

  if (auto_size)
  {
    mdicreate.x       = CW_USEDEFAULT;
    mdicreate.y       = CW_USEDEFAULT;
    mdicreate.cx      = CW_USEDEFAULT;
    mdicreate.cy      = CW_USEDEFAULT;
    mdicreate.style = SW_SHOW;
  }
  else
  {
    mdicreate.x       = 20;
    mdicreate.y       = 20;
    mdicreate.cx      = 400;
    mdicreate.cy      = 260;
    mdicreate.style = SW_SHOWMAXIMIZED;
  }
  mdicreate.szClass = "WcomDraw";
  mdicreate.szTitle = "ComX";
  mdicreate.hOwner  = glob_hinst ;
//  mdicreate.style = 0;
  mdicreate.lParam  = 0;

  glob_wcom = new WCom;
  strcpy(gtmpstr, pickportname);

  stat = glob_wcom->OpenPort(gtmpstr);
  if (stat != 0)
  {
    MessageBox(GetFocus(),"Port failed to open.","",MB_OK);
    return 1;
  }

  // enable settings menu
  EnableMenuItem(hMenuMain,1,MF_BYPOSITION | MF_ENABLED);
  // enable windows menu
  EnableMenuItem(hMenuMain,2,MF_BYPOSITION | MF_ENABLED);

        // create the mdi window
   hwndDraw = (HWND) SendMessage (hwndClient, WM_MDICREATE, (WPARAM) 0,
                       (LPARAM) (LONG) (LPMDICREATESTRUCT) &mdicreate);

  if (hwndDraw == NULL)
  {
    MessageBox(GetFocus(),"Port No Open.","",MB_OK);
    return 1;
  }


  return 0;
}

/*-------------------------------------------------------------------
| WCom::WCom - Constructor
|--------------------------------------------------------------------*/
WCom::WCom()
{
  hwnd = 0;
  hfont = 0;
  next_wcom = NULL;
  com_name[0] = 0;
  com_id = 0;
  ticks  = 0;
  event_ptr   = NULL;
  ev_rec_cnt  = -1;   // win16, rec-cnt notification amount, -1 = disable
  ev_send_cnt = -1;  // win16, send-cnt notification amount, -1 = disable
  event_mask  = 0;   // win16, bit flags of notifications we want
  msr_status = 0;
  mcr_status = (MY_RTS | MY_DTR);
  old_msr_status = 0xff;
  old_mcr_status = 0xff;
  lights_update_flag = 0;
  //display_cur_row = 0;
  //cur_row = 0;
  //cur_col = 0;
  scr_size_x = 0;
  scr_size_y = 0;
  testing_flag = 0;

  in_buf[0] = 0;
  //for (int i=0; i< TROWS;  i++)        /* scroll text */
  //{
  //  text_buf[i][0] = 0;
  //  text_buf[i][TCOLS+2] = 0;
  //}

  ms_starttime = 0;
}

/*-------------------------------------------------------------------
| WCom::~WCom - Destructor
|--------------------------------------------------------------------*/
WCom::~WCom()
{

                          // take ourselves out of open port list
  if (head_wcom == this)  // we are at start of list
    head_wcom = next_wcom;
  else  // not at start of list
  {
    WCom *wc = head_wcom;   // find ourselves in list
    while ((wc->next_wcom != this) && (wc->next_wcom != NULL))
      wc = wc->next_wcom;
    if (wc->next_wcom != NULL)
      wc->next_wcom = next_wcom;  // take ourselves out of list
  }

  if (com_id != NULL)
  {
    PurgeComm(com_id, PURGE_TXABORT);
    PurgeComm(com_id, PURGE_RXABORT);
    CloseHandle(com_id);
    CloseHandle(osRead.hEvent);
    CloseHandle(osWrite.hEvent);
    CloseHandle(osEvent.hEvent);
  }
}

/*-------------------------------------------------------------------
| WCom::OpenPort - Open the port.
|--------------------------------------------------------------------*/
int WCom::OpenPort(char *name)
{
 int stat;
  strcpy(com_name, name);

  char nam_str[20];
  HANDLE hport;

  // this prefix is need to open com-ports above COM9.
  strcpy(nam_str, "\\\\.\\");
  strcat(nam_str, com_name);
  hport = CreateFile(nam_str,
             GENERIC_READ | GENERIC_WRITE,
//             FILE_SHARE_READ | FILE_SHARE_WRITE,  did not work for Win95
             0,  // no sharing
             NULL,                 // no security attrs
             OPEN_EXISTING,
             FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
             NULL);

  if (hport == INVALID_HANDLE_VALUE)
  {
    stat = GetLastError();
    im_mess1("Error from CreateFile:",stat,com_name,0);
    return 1;  // error
  }
  com_id = hport;

  osRead.hEvent = CreateEvent(NULL,    // no security
                              TRUE,    // explicit reset needed.
                              FALSE,   // initial event state
                              NULL);   // no name
  if (osRead.hEvent == NULL)
     im_mess1("Error A CreateEvent",0,NULL,0);


  osWrite.hEvent = CreateEvent( NULL,    // no security
                                TRUE,    // explicit reset needed.
                                FALSE,   // initial event state
                                NULL ) ; // no name
  if (osWrite.hEvent == NULL)
     im_mess1("Error B CreateEvent",0,NULL,0);

  memset(&osEvent,0,sizeof(OVERLAPPED));
  osEvent.hEvent = CreateEvent(NULL,    // no security
                                TRUE,    // explicit reset needed
                                FALSE,   // initial event reset
                                NULL ) ; // no name
  if (osEvent.hEvent == NULL)
    im_mess1("Error C CreateEvent",0,NULL,0);

  InPendingFlag = 0;
  OutPendingFlag = 0;
  EventPendingFlag = 0;

  // see if we want the port defaulted to some value
  if (default_str[0] != 0)
  {
    dcb.DCBlength = sizeof(DCB);
    strcpy(gtmpstr, com_name);
    strcat(gtmpstr, ":");
    strcat(gtmpstr, default_str);

    //MessageBox(GetFocus(),"Using buildcommdcb.",gtmpstr,MB_OK);
    stat = BuildCommDCB(gtmpstr, &dcb);
    if (stat)  // ok
    {
      stat = SetCommState(com_id, &dcb);
      if (stat == 0)
        im_mess1("Error from SetCommState A3:",GetLastError(),NULL,0);
    }
    else
    {
      im_mess1("Error from BuildCommDCB:",GetLastError(),NULL,0);
    }
  }

  PortIdentify();  // see if we can support loopback button

             // add our selves to linked list of opened ports.
  WCom *wc = head_wcom;   // save
  head_wcom = this; // set new
  next_wcom = wc;        // link to last one
  return 0; // ok
}

/*-------------------------------------------------------------------
| WCom::WritePort - send data out the port.
|--------------------------------------------------------------------*/
int WCom::WritePort(unsigned char *str, int cnt)
{
 int stat,j;
 DWORD dwBytesWritten;

  if (cnt == 0) cnt = strlen((char *)str);

  if (OutPendingFlag)         // waiting on last write, need to wait..
  {                           // wait in here:
    if ((stat = WaitForSingleObject(osWrite.hEvent, 6000)) == 0)   // ok
    {
      //  printf("Pending Ok\n");
      if ((stat = GetOverlappedResult(com_id,
                            &osWrite,
                            &dwBytesWritten, FALSE)) == FALSE)
      {
        stat = GetLastError();
        if (stat == ERROR_IO_INCOMPLETE)
             im_mess1("Timeout Comout GetOverLappedResult:",stat,NULL,0);
        else im_mess1("Error Comout GetOverLappedResult:",stat,NULL,0);
      }
      // else wait finished ok.
    }
    else
    {
      stat = GetLastError();
      im_mess1("ComOut Pending Failed, stat:",stat,NULL,0);
    }
    OutPendingFlag = 0;
  }

  stat = WriteFile(com_id, str, cnt, (DWORD *)&j, &osWrite);

  if (stat == FALSE)  // error
  {
    stat = GetLastError();
    if (stat == ERROR_IO_PENDING)  // waiting for completion
      OutPendingFlag = 1;
    else
    {
      im_mess1("Com Write Error:",stat,NULL,0);
    }
  }

 return 0;
}

/*-------------------------------------------------------------------
| WCom::ReadPort - read data from the port.
|--------------------------------------------------------------------*/
int WCom::ReadPort(unsigned char *str, int want_cnt, int *got_cnt)
{
 int stat;

 DWORD BytesRead;

  stat = ReadFile(com_id, str, want_cnt, (DWORD *) &BytesRead, &osRead);

  if (stat == FALSE)  // error
  {
    stat = GetLastError();
    if (stat == ERROR_IO_PENDING)  // waiting for completion
    {
      if ((stat = WaitForSingleObject(osRead.hEvent, 60000)) == 0)  // ok
      {
        // printf("Comin Pending OK\n");
        if ((stat = GetOverlappedResult(com_id,
                            &osRead,
                            &BytesRead, FALSE)) == FALSE)
        {
          stat = GetLastError();
          if (stat == ERROR_IO_INCOMPLETE)
             im_mess1("Timeout Comin GetOverLappedResult:",stat,NULL,0);
          else im_mess1("Error Comin GetOverLappedResult:",stat,NULL,0);
        }
        else
        {
          // osRead.Offset += BytesRead;  // bump comfile ptr
          if (BytesRead != (DWORD)want_cnt)
          {
            im_mess1("ComRead Bytes, got:", BytesRead, ",Wanted:", want_cnt);
            *got_cnt = (int) BytesRead;
            if (BytesRead != 0)
              return 0;  // ok
          }
          else
          {
            *got_cnt = (int) BytesRead;  // bugfix: (added) 8-10-98
            // printf("ComIn Read OK\n");
            return 0;  // ok
          }
        }
      }
      else
      {
        *got_cnt = (int) BytesRead;
        im_mess1("ComIn Pending Failed!:", stat, ",Wanted:", want_cnt);
      }
    }
    else
        im_mess1("Error On Read!:", stat, ",Wanted:", want_cnt);
  }
  else
  {
    if (BytesRead != (DWORD)want_cnt)
      im_mess1("ComRead Error B Bytes, got:", BytesRead, ",Wanted:", want_cnt);

    *got_cnt = (int) BytesRead;
    return 0;  // ok
  }
  return 1;  // error
}

/*------------------------------------------------------------------------
| WCom::StatusPort -
|------------------------------------------------------------------------*/
int WCom::StatusPort(PortStatus *ps)
{
  DWORD ret_stat,stat;
  stat = ClearCommError(com_id, &ret_stat, &cur_com_stat);
  if (stat == FALSE)
  {
    stat = GetLastError();
    wsprintf(gtmpstr,"<ERR %xH,ClearCommError, %s, handle:%x>", stat, com_name, com_id);
    ttywin.mess_str(gtmpstr);  // send to screen
  }
  else
  {
    ps->in_cnt = cur_com_stat.cbInQue;
    ps->out_cnt = cur_com_stat.cbOutQue;

    // check for change in comstat holding bitflags
    if ( *((DWORD *)(&old_com_stat)) != *((DWORD *)(&cur_com_stat)) )
    {
      lights_update_flag = 1;
      // old_com_stat = cur_com_stat;(let screen update do this)
    }

    if (ret_stat)
      print_comm_errors(ret_stat);
  }
  
  return 0;
}

/*------------------------------------------------------------------------
| WCom::check_com_port - poll service routine for serial port.
|------------------------------------------------------------------------*/
void WCom::check_com_port(void)
{
 PortStatus ps;
 int i,j;
 int want_read;
 int got_read;
 int stat;

 char tmpstr[20];
 FILE *fp;
 static char *tst_str = {"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"};

  // get the com_stat record and get the # of characters available
  StatusPort(&ps);

  CheckEvents32();

  if (!testing_flag)
  {
  if ((send_mess_flag) && (ps.out_cnt == 0))
  {
    int send_line;

    if (test_str_len == 0)  // need to make the test string(done once)
    {
      j = 0;
      send_line = 5;
      while ((j< PKT_WRITE_SIZE) && (send_line > 0))// send out about PKT_SIZE bytes at a time.
      {
        for (i=0; i<send_line; i++)
          test_str[j++] = tst_str[i];
        if (send_line > 45)   // devise a string to send
        {
           send_line = 5;
           if (j > 700) send_line = 0;
        }
        else ++send_line;
        test_str[j++] = 0xd;
        test_str[j++] = 0xa;
        test_str[j] = 0;
      }
      test_str_len = j;
    }

    stat = WritePort(test_str, test_str_len);
  }

                           // get the number of characters available
  while (ps.in_cnt > 0)
  {
    want_read = ps.in_cnt;
    if (want_read > PKT_READ_SIZE) want_read = PKT_READ_SIZE;  // our buffer only PKT_READ_SIZE bytes big
    ps.in_cnt -= want_read;

    // read the characters
    stat = ReadPort(in_buf, want_read, &got_read);
    if (stat == 0)
    {
      //if (ps.in_cnt == 0)  // if more to read, don't waste time displaying
      {
        in_buf[got_read] = 0;
        ttywin.mess_str((char *)in_buf, got_read);
      }

      if (save_to_disk)
      {
        strcpy(tmpstr, com_name);
        tmpstr[0] = 'k';  // change to Kom##.txt(using "com" name can be trouble)
        strcat(tmpstr,".txt");
        fp = fopen(tmpstr, "ab");
        if (fp)
        {
          fwrite(in_buf, 1, got_read, fp);
          fclose(fp);
        }
      }
    }
    else
      ttywin.mess_str("Error reading data");
  }
  }  // not testing
}

/*-------------------------------------------------------------------
| CloseEnumProc -
|--------------------------------------------------------------------*/
BOOL FAR PASCAL CloseEnumProc (HWND hwnd, LONG lParam)
{
  if (GetWindow (hwnd, GW_OWNER))         // check for icon title
    return 1;

  SendMessage (GetParent (hwnd), WM_MDIRESTORE, (WPARAM)hwnd, (LPARAM)0L);

  if (!SendMessage (hwnd, WM_QUERYENDSESSION, (WPARAM)0, (LPARAM)0L))
     return 1;

  SendMessage (GetParent (hwnd), WM_MDIDESTROY, (WPARAM)hwnd,(LPARAM) 0L);
    return 1;
}

/*-------------------------------------------------------------------
| WcomWndProc -
|--------------------------------------------------------------------*/
LRESULT FAR PASCAL WcomWndProc(HWND hwnd, UINT message,
						WPARAM wParam, LPARAM lParam)
{
 HDC hdc;
 PAINTSTRUCT ps;
 FARPROC lpProc; /* pointer to the setup_scr function */
 int i;
 char tmpstr[10];


  switch (message)
  {
    case WM_CREATE :
      SetWindowLong(hwnd, 0, (long) glob_wcom);
      glob_wcom->hwnd = hwnd;
      glob_wcom->ms_starttime = GetTickCount();

      glob_wcom->ttywin.init(hwnd);
      glob_wcom->ttywin.set_color(GetSysColor(COLOR_WINDOWTEXT));
      //glob_wcom->ttywin.set_size(0, 0);
      glob_wcom->ttywin.show_crlf = show_crlf;

      hdc = GetDC(hwnd);
      SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
      SetTextColor(hdc, GetSysColor(COLOR_WINDOWTEXT));
      ReleaseDC (hwnd, hdc);

      SetWindowText(hwnd, (char far*)glob_wcom->com_name);
      glob_wcom->ttywin.mess_str("<Port Opened>");
      //glob_wcom->ttywin.mess_str("<Port Opened, Typed keys will be sent, rx-data displayed>\n");

      SetFocus(hwnd);
    return 0;

    case WM_CHAR:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);

      {
        tmpstr[0] = wParam;
        glob_wcom->WritePort((unsigned char *)tmpstr, 1);
      }
    return 0;

    case WM_SETFOCUS:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      glob_wcom->ttywin.show_caret(1);
      ShowCursor(TRUE);
    break;

    case WM_KILLFOCUS:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      glob_wcom->ttywin.show_caret(0);
      ShowCursor(FALSE);
    break;

    case WM_COMMAND:   // message: command from application menu
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      glob_dlg_wcom = glob_wcom;

      switch(wParam)
      {
        case IDM_PURGE_TXABORT:
          PurgeComm(glob_wcom->com_id, PURGE_TXABORT);
          glob_wcom->ttywin.mess_str("<TXABORT called>");
        break;

        case IDM_PURGE_TXCLEAR:
          PurgeComm(glob_wcom->com_id, PURGE_TXCLEAR);
          glob_wcom->ttywin.mess_str("<TXCLEAR called>");
        break;

        case IDM_PURGE_RXABORT:
          PurgeComm(glob_wcom->com_id, PURGE_RXABORT);
          glob_wcom->ttywin.mess_str("<RXABORT called>");
        break;

        case IDM_PURGE_RXCLEAR:
          PurgeComm(glob_wcom->com_id, PURGE_RXCLEAR);
          glob_wcom->ttywin.mess_str("<RXCLEAR called>");
        break;

        case IDM_SETBREAK:
          EscapeCommFunction(glob_wcom->com_id, SETBREAK);
          glob_wcom->ttywin.mess_str("<SETBREAK set>");
        break;

        case IDM_CLRBREAK:
          EscapeCommFunction(glob_wcom->com_id, CLRBREAK);
          glob_wcom->ttywin.mess_str("<CLRBREAK set>");
        break;

        case IDM_SET_TOGGLE_LOW:
          SetToggleLow(glob_wcom->com_id, 1);
        break;

        case IDM_CLEAR_TOGGLE_LOW:
          SetToggleLow(glob_wcom->com_id, 0);
        break;

        case IDM_SETXOFF:
          EscapeCommFunction(glob_wcom->com_id, SETXOFF);
          glob_wcom->ttywin.mess_str("<SETXOFF set>");
        break;

        case IDM_SETXON:
          EscapeCommFunction(glob_wcom->com_id, SETXON);
          glob_wcom->ttywin.mess_str("<SETXON set>");
        break;

        case IDM_CLEARSCR:
          glob_wcom->ttywin.clear_scr();
        break;

        case IDM_LOOPTEST:
          glob_wcom->loop_test();
        break;

        case IDM_PNP_ID:
          glob_wcom->get_pnp_id();
        break;

        case IDM_PORT_SETTINGS:
          lpProc = MakeProcInstance((FARPROC)settings_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "EASYDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_QSIZES:
          lpProc = MakeProcInstance((FARPROC)qsizes_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "QSIZESDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_LINE_SETTINGS:
          lpProc = MakeProcInstance((FARPROC)options_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "SETTINGSDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_MISC:
          lpProc = MakeProcInstance((FARPROC)misc_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "MISCDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_TIMEOUTS:
          lpProc = MakeProcInstance((FARPROC)timeouts_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "WINTIMEOUTS", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_EVENTS:
          lpProc = MakeProcInstance((FARPROC)events_dlg_proc, glob_hinst);
          DialogBox(glob_hinst, "EVENTSDLGBOX", hwnd, (DLGPROC) lpProc);
          FreeProcInstance(lpProc);
        return 0;

        case IDM_EXIT:
          SendMessage (hwndFrame, WM_CLOSE, (WPARAM)0L, (LPARAM)0L) ;
        break;

        default:
        break;
      }
    return 0;

    case WM_PAINT:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);

      hdc = BeginPaint(hwnd, &ps);
      EndPaint (hwnd, &ps);

      glob_wcom->update_lights(1);  // update lights
      glob_wcom->ttywin.update_screen(1);  // update whole screen
    return 0;

    case WM_MDIACTIVATE:
      // Set the Draw menu if gaining focus
    return 0;

    case WM_QUERYENDSESSION:
    case WM_CLOSE:
    break ;   // ie, call DefMDIChildProc

    case WM_MOUSEMOVE:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      glob_wcom->cur_x = LOWORD(lParam);
      glob_wcom->cur_y = HIWORD(lParam);
    break;

//    case WM_LBUTTONDOWN:
//    case WM_RBUTTONDOWN:
    case WM_LBUTTONUP:
    case WM_RBUTTONUP:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      if (glob_wcom->cur_y < 16)
      {
        i = 0;
        while ((buttons[i] != NULL) && (i < glob_wcom->num_buttons))
        {
          if ((glob_wcom->cur_x > buttons_x[i]) &&
              (glob_wcom->cur_x < buttons_x[i]+buttons_size[i]))
          {
            switch (i)
            {
              case 0:
              case 1:
              case 2:
              case 3:
        MessageBox(GetFocus(),"These are inputs, so cannot be controlled!","",MB_OK);
              break;
              case 4:
                if (PlatformId == VER_PLATFORM_WIN32_NT)
                {
                  // NT can't override rts control, in 95 you can
                  if (glob_wcom->dcb.fRtsControl >= 2) 
                     // control state, can't override
                  {
        MessageBox(GetFocus(),"Can't override RTS when in handshake mode in NT!","",MB_OK);
                     break;  // don't allow toggle
                  }
                }
          if (glob_wcom->mcr_status & MY_RTS)
               EscapeCommFunction(glob_wcom->com_id, CLRRTS);
          else EscapeCommFunction(glob_wcom->com_id, SETRTS);
          glob_wcom->mcr_status ^= MY_RTS;
              break;

              case 5:
          if (glob_wcom->mcr_status & MY_DTR)
               EscapeCommFunction(glob_wcom->com_id, CLRDTR);
          else EscapeCommFunction(glob_wcom->com_id, SETDTR);
          glob_wcom->mcr_status ^= MY_DTR;
              break;

              case 6:
               if (glob_wcom->mcr_status & MY_LOOPBACK)
               {
                 glob_wcom->LoopBack(0);  // turn off
               }
               else
               {
                 glob_wcom->LoopBack(1);  // turn on
               }
              break;
            }  // switch ()
          }  // if button hit
          ++i;
        }  // while
      }
    break;

    case WM_SIZE:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      glob_wcom->ttywin.set_size(LOWORD(lParam), HIWORD(lParam));
      glob_wcom->scr_size_x = LOWORD(lParam);
      glob_wcom->scr_size_y = HIWORD(lParam);
    break;

    case WM_DESTROY:
      glob_wcom = (WCom *) GetWindowLong(hwnd,0);
      delete glob_wcom;
    return 0;
  }
      // Pass unprocessed message to DefMDIChildProc
  return DefMDIChildProc (hwnd, message, wParam, lParam);
}

/*--------------------------------------------------------------------
| WCom::PortIdentify - We have the port open, try a few ioctl's to
    see if its a port that supports Comtrols custom loopback ioctl's.
    If not, then make it so <loop> button does not show.
    The loopback is used to set hardware loopback, which is convienent
    for testing quickly.  Stock com-ports don't do this because the
    hardware does not support a feature like this.
|---------------------------------------------------------------------*/
int WCom::PortIdentify(void)
{
 int stat;
 DWORD nBytes = 0;

  loop_supported = 0;  // default to no loop
  if (PlatformId == VER_PLATFORM_WIN32_NT)
  {
          // following only in RocketPort WinNT driver currently.
   stat = DeviceIoControl(glob_wcom->com_id, IOCTL_RCKT_LOOPBACK_OFF,
                          (char *)NULL, 0, (char *)NULL, 0,  // out
                          &nBytes, 0);
   if (stat == 1)  // success
    loop_supported = 1;
  }
  else // win95 assume
  {
    if (IsWindows98())
    {
      // calling escapecommfunction with a custom ioctl and a stock
      // com-port crashes app under Win98.  So lets avoid this by
      // detecting when we are running Win98 and not calling it.
   }
   else
   {
          // following only in RocketPort Win95 driver currently.
     stat = EscapeCommFunction(glob_wcom->com_id, 15649);  // loop off
     if (stat == 1)  // success
       loop_supported = 1;
   }
  }

  if (loop_supported)
    num_buttons = 7;
  else
    num_buttons = 6;
  return 0;
}

/*--------------------------------------------------------------------
| IsWindows98 - Return 1 if Windows98, 0 if not.
|---------------------------------------------------------------------*/
static int IsWindows98(void)
{
 OSVERSIONINFO os;  // about 150 bytes big

  if (PlatformId == VER_PLATFORM_WIN32_NT)
    return 0;  // its NT
  else
  {
    os.dwOSVersionInfoSize = sizeof(os);
    GetVersionEx(&os);  // nt or win95 or win32s
    // win98 reports major:4, minor:10, build:67766222
    // win95 reports major:4, minor:0,  build:67109975
    //im_mess1("major:",os.dwMajorVersion, "minor:", os.dwMinorVersion);
    if ((os.dwMajorVersion > 4) || (os.dwMinorVersion > 9))
    {
      // must be Win98, so just don't allow custom ioctls.
      return 1;  // yes, looks like win98
    }
  }
  return 0; // not, probably win95
}

/*--------------------------------------------------------------------
| SetToggleLow - Override the port into RTS toggle mode on transmit.
   The override also sets the port to toggling RTS low on transmit(
   instead of the default high.)  This is what is needed for the RS485
   RocketPort product.
   This is intended for RS485 RocketPort product support, which
   requires RTS to toggle low on transmit.

  Params:
    hCom - Handle to port.
    on - set to 1 if we want 485 toggle override on, 0 to turn it off.
|---------------------------------------------------------------------*/
int SetToggleLow(HANDLE hCom, int on)
{
  DWORD nBytes = 0;
  int stat;
  DWORD ioctl_id;

  DWORD PlatformID;
  OSVERSIONINFO os;  // about 150 bytes big

  // don't do this in 98, as it will crash the app on stock com-ports
  // and we have no way to detect if its a RocketPort now
  if (IsWindows98())  
  { 
    return 1; // err
  }

  os.dwOSVersionInfoSize = sizeof(os);
  if (FALSE == GetVersionEx(&os))  // nt or win95 or win32s
  {
    PlatformID = VER_PLATFORM_WIN32_NT;
  }
  else
    PlatformID = os.dwPlatformId;


    if (PlatformID == VER_PLATFORM_WIN32_NT)
    {
      if (on)
           ioctl_id = IOCTL_RCKT_SET_TOGGLE_LOW;
      else ioctl_id = IOCTL_RCKT_CLEAR_TOGGLE_LOW;

            // following only in RocketPort WinNT driver currently.
     stat = DeviceIoControl(hCom, ioctl_id,
                            (char *)NULL, 0, (char *)NULL, 0,  // out
                            &nBytes, 0);
    }
    else // win95 assume
    {
      if (on)
           ioctl_id = RTSTOGGLE_ON;
      else ioctl_id = RTSTOGGLE_OFF;

            // following only in RocketPort Win95 driver currently.
      stat = EscapeCommFunction(hCom, ioctl_id);  // low toggle on
    }
  return 0;
}

/*--------------------------------------------------------------------
| WCom::LoopBack - Send a mesage to the Comtrol RocketPort driver
   to set the port hardware in loopback state.  This is a custom
   feature of the RocketPort, which add's a convienent <loop> loopback
   button to the port screen for easy verification that the driver
   and hardware are(for the most part) functional.
|---------------------------------------------------------------------*/
int WCom::LoopBack(int on)
{
  DWORD nBytes = 0;
  int stat;

  // don't do this in 98, as it will crash the app on stock com-ports
  // and we have no way to detect if its a RocketPort now
  if (IsWindows98())  
  { 
    return 1; // err
  }

  if (on)
  {
    mcr_status |= MY_LOOPBACK;
    if (PlatformId == VER_PLATFORM_WIN32_NT)
    {
            // following only in RocketPort WinNT driver currently.
     stat = DeviceIoControl(glob_wcom->com_id, IOCTL_RCKT_LOOPBACK_ON,
                            (char *)NULL, 0, (char *)NULL, 0,  // out
                            &nBytes, 0);
    }
    else // win95 assume
    {
            // following only in RocketPort Win95 driver currently.
      stat = EscapeCommFunction(glob_wcom->com_id, 15648);  // loop on
    }
  }
  else  // turn off
  {
    mcr_status &= ~MY_LOOPBACK;
    if (PlatformId == VER_PLATFORM_WIN32_NT)
    {
            // following only in RocketPort WinNT driver currently.
      stat = DeviceIoControl(glob_wcom->com_id, IOCTL_RCKT_LOOPBACK_OFF,
                         (char *)NULL, 0, (char *)NULL, 0,  // out
                         &nBytes, 0);
    }
    else // win95 assume
    {
            // following only in RocketPort Win95 driver currently.
      stat = EscapeCommFunction(glob_wcom->com_id, 15649);  // loop off
    }
  }
  return 0;
}

/*--------------------------------------------------------------------
| WCom::CheckEvents32 - Check for Events and ModemStatus(Win32).
|---------------------------------------------------------------------*/
int WCom::CheckEvents32(void)
{
#ifdef WIN32
 DWORD num_something;
 DWORD stat;

 DWORD ModemStatus;
 DWORD ms_last_stat; // avoid million error windows on screen due to polling

  stat = GetCommModemStatus(com_id, &ModemStatus);
  if (stat == FALSE)
  {
    if (ms_last_stat == 0)
    {
      stat = GetLastError();
      im_mess1("GetCommModemStatus Error:",stat,0,0);
    }
  }
  ms_last_stat = stat;

  msr_status = 0;
  if (ModemStatus & MS_CTS_ON)
    msr_status |= ACE_CTS;
  if (ModemStatus & MS_DSR_ON)
    msr_status |= ACE_DSR;
  if (ModemStatus & MS_RLSD_ON)
    msr_status |= ACE_RLSD;
  if (ModemStatus & MS_RING_ON)
    msr_status |= ACE_RI;


  if (EventPendingFlag)
  {
    if ((stat = GetOverlappedResult(com_id,
                                    &osEvent,
                                    &num_something,
                                    FALSE)    // don't wait
                                          ) == FALSE)
    {
      stat = GetLastError();
      if (stat != ERROR_IO_INCOMPLETE)
      {
         im_mess1("Error Com Event GetOverLappedResult:",stat,0,0);
         EventPendingFlag = 0;
      }
    }
    else
    {
      print_events(events); // print events to screen
      EventPendingFlag = 0;
    }
  }

  if (EventPendingFlag)  // waiting
  {
    return 0;
  }

  if (event_mask == 0)
  {
    return 0;
  }

  stat = WaitCommEvent(com_id, &events, &osEvent);

  if (stat == FALSE)  // error
  {
    stat = GetLastError();
    if (stat == ERROR_IO_PENDING)  // waiting for completion
      EventPendingFlag = 1;
    else
    {
static int errs = 0;
      ++errs;
      if (errs > 4) return 1;
      im_mess1("Event Wait Error:",stat,0,0);
    }
  }
  else
  {
    print_events(events); // print events to screen
  }


#endif

  return 0;
}

/*--------------------------------------------------------------------
| WCom::print_comm_errors -
|---------------------------------------------------------------------*/
void WCom::print_comm_errors(unsigned int err)
{
  if (err & CE_BREAK)   ttywin.mess_str("<ERR:BREAK>");
  if (err & CE_FRAME)   ttywin.mess_str("<ERR:FRAME>");
  if (err & CE_IOE)     ttywin.mess_str("<ERR:IOE>");
  if (err & CE_MODE)    ttywin.mess_str("<ERR:MODE>");
  if (err & CE_OVERRUN) ttywin.mess_str("<ERR:OVERRUN>");
  if (err & CE_RXOVER)  ttywin.mess_str("<ERR:RXOVER>");
  if (err & CE_RXPARITY)ttywin.mess_str("<ERR:RXPARITY>");
  if (err & CE_TXFULL)  ttywin.mess_str("<ERR:TXFULL>");
  if (err & CE_DNS)     ttywin.mess_str("<ERR:DNS>");
  if (err & CE_PTO)     ttywin.mess_str("<ERR:PTO>");
  if (err & CE_OOP)     ttywin.mess_str("<ERR:OOP>");
}

/*--------------------------------------------------------------------
| WCom::print_modem_state -
|---------------------------------------------------------------------*/
void WCom::print_modem_state(unsigned int modem_state)
{
#ifdef COMMENT_OUT
 char tmpstr[40];
 wsprintf(tmpstr,"<MODEM STATE: %s %s %s %s>",
 (modem_state & MS_CTS_ON)   ? " CTS"  : " cts"  ,
 (modem_state & MS_DSR_ON)   ? " DSR"  : " dsr"  ,
 (modem_state & MS_RING_ON)  ? " RING" : " ring" ,
 (modem_state & MS_RLSD_ON)  ? " RLSD" : " rlsd" );
 ttywin.mess_str(tmpstr);
#endif
 ttywin.mess_str("STATE!");
}

/*--------------------------------------------------------------------
| WCom::print_events -
|---------------------------------------------------------------------*/
void WCom::print_events(unsigned int events)
{
  if (events == 0)  ttywin.mess_str("<EV_NONE>");
  if (events & EV_RXCHAR)  ttywin.mess_str("<EV_RXCHAR>");
  if (events & EV_RXFLAG)  ttywin.mess_str("<EV_RXFLAG>");
  if (events & EV_TXEMPTY) ttywin.mess_str("<EV_TXEMPTY>");
  if (events & EV_CTS)     ttywin.mess_str("<EV_CTS>");
  if (events & EV_DSR)     ttywin.mess_str("<EV_DSR>");
  if (events & EV_RLSD)    ttywin.mess_str("<EV_RLSD>");
  if (events & EV_BREAK)   ttywin.mess_str("<EV_BREAK>");
  if (events & EV_ERR)     ttywin.mess_str("<EV_ERR>");
  if (events & EV_RING)    ttywin.mess_str("<EV_RING>");
  if (events & EV_PERR)    ttywin.mess_str("<EV_PERR>");
#ifdef WIN32
  if (events & EV_RX80FULL)    ttywin.mess_str("<EV_RX80FULL>");
  if (events & EV_EVENT1)    ttywin.mess_str("<EV_EVENT1>");
  if (events & EV_EVENT2)   ttywin.mess_str("<EV_EVENT2>");
#else
  if (events & EV_CTSS)    ttywin.mess_str("<EV_CTSS>");
  if (events & EV_DSRS)    ttywin.mess_str("<EV_DSRS>");
  if (events & EV_RLSDS)   ttywin.mess_str("<EV_RLSDS>");
  if (events & EV_RingTe)  ttywin.mess_str("<EV_RingTe>");
#endif
}

/*------------------------------------------------------------------------
| im_mess1 -
|------------------------------------------------------------------------*/
void im_mess1(char *str1, int i1, char *str2, int i2)
{
 char tmpstr[100];

 if (str2 == NULL)
		sprintf(tmpstr,"%s%d",str1,i1);
 else wsprintf(tmpstr,"%s %d %s %d",str1,i1,str2,i2);

 MessageBox(hwndFrame, tmpstr, NULL, MB_OK | MB_ICONQUESTION);
}

#if 0
/*------------------------------------------------------------------------
| WCom::mess_line -
|------------------------------------------------------------------------*/
void WCom::mess_line(char *str, int line_num)
{
 HDC hdc;

  hdc = GetDC(hwnd);
  TextOut(hdc, 20, line_num*20, str, strlen(str));
  ReleaseDC(hwnd, hdc);
}

/*------------------------------------------------------------------------
| WCom::mess_num - send a number out to debug text window.
|------------------------------------------------------------------------*/
void WCom::mess_num(int num)
{
 char tmpstr[20];

  wsprintf(tmpstr,":%d ",num);
  ttywin.mess_str(tmpstr);
}
#endif

/*------------------------------------------------------------------------
 draw_light - draw the buttons at top of window.
|------------------------------------------------------------------------*/
static void draw_light(HDC hdc, int on, int index, int flags)
{
 HBRUSH new_brush, old_brush;
 LOGBRUSH log_brush;
 RECT rect;
 int i;
 char str[10];
 
  strcpy(str,buttons[index]);

  rect.top  = 1;
  rect.left = buttons_x[index];
  rect.bottom  = rect.top + 16;
  rect.right = rect.left + buttons_size[index];

  SelectObject(hdc,GetStockObject(BLACK_PEN));
  SelectObject(hdc,GetStockObject(LTGRAY_BRUSH));

  if (on)
  {
    log_brush.lbStyle = 0;  // solid brush
    log_brush.lbColor = RGB(128,255,128);  // green
    new_brush = CreateBrushIndirect(&log_brush);
    old_brush = (HBRUSH) SelectObject(hdc,new_brush);
    RoundRect(hdc, rect.left, rect.top, rect.right, rect.bottom,6,8);
    SelectObject(hdc,old_brush);
    DeleteObject(new_brush);
  }
  else
  {
    i=0;  // convert to lower case
    while (str[i] != 0)
    {
      //str[i++] &= ~0x30;
      str[i] = tolower(str[i]);
      ++i;
    }

    RoundRect(hdc, rect.left, rect.top, rect.right, rect.bottom,6,8);
  }

  SetBkMode(hdc,TRANSPARENT);
  SetTextColor(hdc, RGB(0,0,0)); // black
  DrawText(hdc, str, strlen(str), &rect, 1);
}

/*------------------------------------------------------------------------
 draw_hold_light - draw the lights at top of window for holding state.
   Put up a light if they are on, if off then don't display a light.
|------------------------------------------------------------------------*/
static void draw_hold_light(HDC hdc, int index, int flags)
{
 HBRUSH new_brush, old_brush;
 LOGBRUSH log_brush;
 RECT rect;
 int i;
 char str[10];
#define START_X_POS 240

  strcpy(str,hold_buttons[index]);

  i=0;  // convert to lower case
  while (str[i] != 0)
  {
    //str[i++] &= ~0x30;
    str[i] = tolower(str[i]);
    ++i;
  }

  rect.top  = 1;
  rect.left = hold_buttons_x[index] + START_X_POS;
  rect.bottom  = rect.top + 16;
  rect.right = rect.left + hold_buttons_size[index];

  // clear out the background for all holding lights(blue)
  if (flags & 1)
  {
    new_brush = CreateSolidBrush(GetSysColor(COLOR_WINDOW));  // for painting window
    SelectObject(hdc,GetStockObject(NULL_PEN));
    old_brush = (HBRUSH) SelectObject(hdc, new_brush);
    Rectangle(hdc, START_X_POS, rect.top, 500, rect.bottom);
    SelectObject(hdc,old_brush);
    DeleteObject(new_brush);
    return;
  }

  SelectObject(hdc,GetStockObject(BLACK_PEN));
  SelectObject(hdc,GetStockObject(LTGRAY_BRUSH));

  // display the blue holding light
  log_brush.lbStyle = 0;  // solid brush
  log_brush.lbColor = RGB(128,128,255);  // blue
  new_brush = CreateBrushIndirect(&log_brush);
  old_brush = (HBRUSH) SelectObject(hdc,new_brush);
  RoundRect(hdc, rect.left, rect.top, rect.right, rect.bottom,6,8);
  SelectObject(hdc,old_brush);
  DeleteObject(new_brush);

  SetBkMode(hdc,TRANSPARENT);
  SetTextColor(hdc, RGB(0,0,0)); // black
  DrawText(hdc, str, strlen(str), &rect, 1);
}

/*------------------------------------------------------------------------
 WCom::update_lights - update anything which needs to be drawn on screen.
   Idea here is that the display data gets dumped into a circular
   buffer which we display to the screen(at a low priority).
|------------------------------------------------------------------------*/
void WCom::update_lights(int all_flag)
{
 //int i;
 HDC hdc;
 //int max_row;
 //int write_y;
 //int dis_row;
 //char *txt;
 //int scr_update_done = 0;

 HFONT new_hfont = NULL;

#define ROW_HEIGHT 14

  if (scr_size_y < 4)
    return;
    
  hdc = GetDC(hwnd);
      //---- first do fancy light gizmo indicators
  if ((old_msr_status != msr_status) ||
      (old_mcr_status != mcr_status) ||
      all_flag)
  {
    old_msr_status = msr_status;
    old_mcr_status = mcr_status;

    draw_light(hdc, msr_status & ACE_CTS, 0, 0);
    draw_light(hdc, msr_status & ACE_DSR, 1, 0);
    draw_light(hdc, msr_status & ACE_RLSD, 2, 0);
    draw_light(hdc, msr_status & ACE_RI, 3, 0);

    draw_light(hdc, mcr_status & MY_RTS, 4, 0);
    draw_light(hdc, mcr_status & MY_DTR, 5, 0);
    if (num_buttons >= 7)
      draw_light(hdc, mcr_status & MY_LOOPBACK, 6, 0);
  }

  // do holding-reasons indicator lights
  if ( (*((DWORD *)(&old_com_stat)) != *((DWORD *)(&cur_com_stat))) ||
      all_flag)
  {
    draw_hold_light(hdc, 0, 1);  // erase area

    if (cur_com_stat.fCtsHold)
      draw_hold_light(hdc, 0, 0);
    if (cur_com_stat.fDsrHold)
      draw_hold_light(hdc, 1, 0);
    if (cur_com_stat.fRlsdHold)
      draw_hold_light(hdc, 2, 0);
    if (cur_com_stat.fXoffHold)
      draw_hold_light(hdc, 3, 0);
    if (cur_com_stat.fXoffSent)
      draw_hold_light(hdc, 4, 0);
    if (cur_com_stat.fEof)
      draw_hold_light(hdc, 5, 0);
    if (cur_com_stat.fTxim)
      draw_hold_light(hdc, 6, 0);

    old_com_stat = cur_com_stat;
  }
  ReleaseDC(hwnd, hdc);
}

/*------------------------------------------------------------------------
| WCom::loop_test - perform a loopback test
|------------------------------------------------------------------------*/
void WCom::loop_test(void)
{
 PortStatus ps;
 int stat, failed, got_read;
 DWORD ModemStatus;
 char tmpstr[40];
 char header_str[80];
 DCB org_dcb; // original
 DCB new_dcb;
 int changed_dcb = 0;
 int ri_ok = 0;

  strcpy(header_str, apname);
  strcat(header_str, " - Loopback Test");
  org_dcb.DCBlength = sizeof(DCB);
  new_dcb.DCBlength = sizeof(DCB);

  if (send_mess_flag)  // sending test string
  {
    send_mess_flag = 0;  // turn off
    CheckMenuItem (hMenuMain,IDM_SENDMESS,  MF_UNCHECKED);
  }

  wsprintf(gtmpstr, "Place the loopback plug on %s", com_name);
  if (MessageBox(GetFocus(), gtmpstr, header_str,MB_OKCANCEL) == IDCANCEL)
  {
    return;
  }

  glob_wcom->testing_flag = 1;  // flag to stop main processing while testing

  if (mcr_status & MY_LOOPBACK)
  {
    glob_wcom->LoopBack(0);  // turn off
    mcr_status &= ~MY_LOOPBACK;
  }

  // kill any data in buffers
  PurgeComm(com_id, PURGE_TXABORT);
  PurgeComm(com_id, PURGE_RXABORT);

  Sleep(200);  // wait 200ms

                             // read in the current port settings
  GetCommState(com_id, &org_dcb);

  if ((org_dcb.fDtrControl > 1) || (org_dcb.fRtsControl > 1)) // if auto-handshakes
  {
    GetCommState(com_id, &new_dcb);
    changed_dcb = 1;  // remind to restore
    new_dcb.fRtsControl = 0;
    new_dcb.fDtrControl = 0;
    SetCommState(com_id, &new_dcb);
  }

  failed = 0;

  //------- turn dtr off, rts off
  EscapeCommFunction(com_id, CLRDTR);
  EscapeCommFunction(com_id, CLRRTS);
  mcr_status = (MY_DTR | MY_RTS);
  Sleep(200);  // wait 200ms

  GetCommModemStatus(com_id, &ModemStatus);
  if (ModemStatus & (MS_DSR_ON | MS_RLSD_ON | MS_CTS_ON))
    failed |= 0x0001;

  if ((ModemStatus & MS_RING_ON) == 0)  // do we see ring indicator?
    ri_ok |= 1;

  //------- turn dtr off, rts on
  EscapeCommFunction(com_id, CLRDTR);
  EscapeCommFunction(com_id, SETRTS);
  mcr_status = MY_RTS;
  Sleep(200);  // wait 200ms

  GetCommModemStatus(com_id, &ModemStatus);
  if ((ModemStatus & (MS_DSR_ON | MS_CTS_ON)) != MS_CTS_ON)
    failed |= 0x0002;

  if (ModemStatus & MS_RING_ON)  // do we see ring indicator?
    ri_ok |= 2; // wired to RTS on comtrol loopback.

  //------- turn dtr on, rts off
  EscapeCommFunction(com_id, SETDTR);
  EscapeCommFunction(com_id, CLRRTS);
  mcr_status = MY_DTR;
  Sleep(200);  // wait 200ms

  GetCommModemStatus(com_id, &ModemStatus);
  if ((ModemStatus & (MS_DSR_ON | MS_CTS_ON)) != MS_DSR_ON)
    failed |= 0x0004;

  //------- turn dtr on, rts on
  EscapeCommFunction(com_id, SETDTR);
  EscapeCommFunction(com_id, SETRTS);
  mcr_status = MY_DTR | MY_RTS;
  Sleep(200);  // wait 200ms

  GetCommModemStatus(com_id, &ModemStatus);
  if ((ModemStatus & (MS_DSR_ON | MS_RLSD_ON | MS_CTS_ON)) !=
                     (MS_DSR_ON | MS_RLSD_ON | MS_CTS_ON))
    failed |= 0x0008;

  //---- send some test data
  WritePort((unsigned char *) "TESTING", 8);
  Sleep(200);  // wait 200ms

  // get the com_stat record and get the # of characters available
  StatusPort(&ps);

  if (ps.in_cnt != 8)
  {
    failed |= 0x0010;
  }
  else
  {
    stat = ReadPort((unsigned char *) tmpstr, 8, &got_read);
    if (tmpstr[7] != 0)
      failed |= 0x0020;
    if (tmpstr[0] != 'T')
      failed |= 0x0040;
  }

  if (changed_dcb)
    SetCommState(com_id, &org_dcb);

  if (failed)
  {
    wsprintf(gtmpstr, "Port failed loopback test(Error:%xH)", failed);
    MessageBox(GetFocus(), gtmpstr, header_str, MB_OK | MB_ICONSTOP);
  }
  else
  {
    wsprintf(gtmpstr, "%s passed the loopback test.", com_name);

    if (ri_ok == 3) // RI is present(give an indication that it was found)
      strcat(gtmpstr, " RI present.");

    MessageBox(GetFocus(), gtmpstr, header_str, MB_OK | MB_ICONINFORMATION);
  }

  glob_wcom->testing_flag = 0;  // flag to stop main processing while testing
}

/*------------------------------------------------------------------------
| WCom::get_pnp_id - toggle dtr,rts to get pnp id string from pnp-aware
   modems and peripherals.
|------------------------------------------------------------------------*/
void WCom::get_pnp_id(void)
{
 PortStatus ps;
 //int stat;
 //char tmpstr[40];
 char header_str[80];
 DCB org_dcb; // original
 DCB new_dcb;
 int changed_dcb = 0;

  strcpy(header_str, apname);
  strcat(header_str, " - PnP Id Helper");
  org_dcb.DCBlength = sizeof(DCB);
  new_dcb.DCBlength = sizeof(DCB);

  if (send_mess_flag)  // sending test string
  {
    send_mess_flag = 0;  // turn off
    CheckMenuItem (hMenuMain,IDM_SENDMESS,  MF_UNCHECKED);
  }

  wsprintf(gtmpstr,
"This will toggle RTS,DTR to retrieve PnP ID on %s", com_name);
  if (MessageBox(GetFocus(), gtmpstr, header_str,MB_OKCANCEL) == IDCANCEL)
  {
    return;
  }

  glob_wcom->testing_flag = 1;  // flag to stop main processing while testing

  if (mcr_status & MY_LOOPBACK)
  {
    glob_wcom->LoopBack(0);  // turn off
    mcr_status &= ~MY_LOOPBACK;
  }

  // kill any data in buffers
  PurgeComm(com_id, PURGE_TXABORT);
  PurgeComm(com_id, PURGE_RXABORT);

  Sleep(200);  // wait 200ms

                             // read in the current port settings
  GetCommState(com_id, &org_dcb);
  GetCommState(com_id, &new_dcb);

  if ((org_dcb.fDtrControl > 1) || (org_dcb.fRtsControl > 1)) // if auto-handshakes
  {
    changed_dcb = 1;  // remind to restore
    new_dcb.fRtsControl = 0;
    new_dcb.fDtrControl = 0;
    SetCommState(com_id, &new_dcb);
  }

  if ((new_dcb.BaudRate != 1200) ||
       (new_dcb.ByteSize != 7) ||
       (new_dcb.StopBits != 0) ||
       (new_dcb.Parity != 0))
  {

    if (MessageBox(GetFocus(), 
      "Setup to 1200,7,n,1?", header_str,MB_YESNO) == IDYES)
    {
      if ((new_dcb.BaudRate != 1200) ||
         (new_dcb.ByteSize != 7) ||
         (new_dcb.StopBits != 0) ||
         (new_dcb.Parity != 0))
      {
        new_dcb.BaudRate = 1200;
        new_dcb.ByteSize = 7;
        new_dcb.StopBits = 0;
        new_dcb.Parity = 0;
        SetCommState(com_id, &new_dcb);
      }
    }
  }

  //------- turn dtr off, rts off
  EscapeCommFunction(com_id, CLRDTR);
  EscapeCommFunction(com_id, CLRRTS);
  mcr_status = (MY_DTR | MY_RTS);
  Sleep(1000);  // wait 1000ms

  //------- turn dtr on, rts off
  EscapeCommFunction(com_id, SETDTR);
  EscapeCommFunction(com_id, CLRRTS);
  mcr_status = MY_RTS;

  // heres the critical time signiture
  Sleep(200);  // wait 200ms

  //------- turn dtr on, rts on
  EscapeCommFunction(com_id, SETDTR);
  EscapeCommFunction(com_id, SETRTS);
  mcr_status = MY_DTR | MY_RTS;
  Sleep(200);  // give time for responce

  // get the com_stat record and get the # of characters available
  StatusPort(&ps);

  if (ps.in_cnt == 0)
  {
    MessageBox(GetFocus(), "No PnP data received", header_str, MB_OK | MB_ICONSTOP);
  }

  if (changed_dcb)
    SetCommState(com_id, &org_dcb);

  glob_wcom->testing_flag = 0;  // flag to stop main processing while testing

}

/*-------------------------------------------------------------------
| SetMiscDlgInfo - Port Options Dialog, setup field values.
|  Misc DCB fields.
|--------------------------------------------------------------------*/
static void SetMiscDlgInfo(HWND hDlg)
{

 unsigned long num;
 int stat;
 DCB *dcb = &glob_dlg_wcom->dcb;

  // common Win16 & Win32
  //------------------ fNull: Enable Null stripping
  dcb->fNull = IsDlgButtonChecked( hDlg, IDC_fNull);

  //------------------ xonchar
  if (GetDlgItemNumb(hDlg, IDC_XonChar, &num) == 0)
    dcb->XonChar = (BYTE) num;

  //------------------ xoffchar
  if (GetDlgItemNumb(hDlg, IDC_XoffChar, &num) == 0)
    dcb->XoffChar = (BYTE) num;

  //------------------ xonlim
  if (GetDlgItemNumb(hDlg, IDC_XonLim, &num) == 0)
    dcb->XonLim = (WORD) num;

  //------------------ xofflim
  if (GetDlgItemNumb(hDlg, IDC_XoffLim, &num) == 0)
    dcb->XoffLim = (WORD) num;

  //------------------ eofchar
  if (GetDlgItemNumb(hDlg, IDC_EofChar, &num) == 0)
    dcb->EofChar = (BYTE) num;

  //------------------ evtchar
  if (GetDlgItemNumb(hDlg, IDC_EvtChar, &num) == 0)
    dcb->EvtChar = (BYTE) num;

  EnableWindow(GetDlgItem(hDlg, IDC_fBinary),0);
  EnableWindow(GetDlgItem(hDlg, IDC_fPeChar),0);
  EnableWindow(GetDlgItem(hDlg, IDC_fChEvt),0);
  EnableWindow(GetDlgItem(hDlg, IDC_PeChar),0);
  EnableWindow(GetDlgItem(hDlg, IDC_TxDelay),0);

  //------------ Win32 special
  //------------------ DSR Sensitivity
  dcb->fDsrSensitivity = IsDlgButtonChecked( hDlg, IDC_fDsrSensitivity);

  //------------------ Continue TX when Xoff sent
  dcb->fTXContinueOnXoff = IsDlgButtonChecked( hDlg, IDC_fTXContinueOnXoff);

  //------------------ Enable Err Replacement
  dcb->fErrorChar = IsDlgButtonChecked( hDlg, IDC_fErrorChar);

  //------------------ Abort all reads and writes on Error
  dcb->fAbortOnError = IsDlgButtonChecked( hDlg, IDC_fAbortOnError);

  //------------------ Error replacement char
  if (GetDlgItemNumb(hDlg, IDC_ErrorChar, &num) == 0)
    dcb->ErrorChar = (BYTE) num;

  stat = SetCommState(glob_dlg_wcom->com_id,dcb);
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
  if (stat != 0)
    im_mess1("Error from SetCommState:",stat,0,0);
}

/*-------------------------------------------------------------------
| GetMiscDlgInfo - Port Options Dialog, setup field values.
|  Misc DCB fields.
|--------------------------------------------------------------------*/
static void GetMiscDlgInfo(HWND hDlg)
{
// HWND hwnd;
 char tmpstr[80];
 int stat;
 DCB *dcb = &glob_dlg_wcom->dcb;

                             // read in the current port settings
  stat = GetCommState(glob_dlg_wcom->com_id, dcb);
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();

  if (stat != 0)
    im_mess1("Error from GetCommState:",stat,0,0);

  // common Win16 & Win32
  //------------------ fNull: Enable Null stripping
  SendDlgItemMessage(hDlg, IDC_fNull, BM_SETCHECK, dcb->fNull, 0);

  //------------------ xonchar
  wsprintf(tmpstr,"%u",dcb->XonChar);
  SetDlgItemText(hDlg, IDC_XonChar, tmpstr);

  //------------------ xoffchar
  wsprintf(tmpstr,"%u",dcb->XoffChar);
  SetDlgItemText(hDlg, IDC_XoffChar, tmpstr);

  //------------------ xonlim
  wsprintf(tmpstr,"%u",dcb->XonLim);
  SetDlgItemText(hDlg, IDC_XonLim, tmpstr);

  //------------------ xofflim
  wsprintf(tmpstr,"%u",dcb->XoffLim);
  SetDlgItemText(hDlg, IDC_XoffLim, tmpstr);

  //------------------ eofchar
  wsprintf(tmpstr,"%u",(BYTE) dcb->EofChar);
  SetDlgItemText(hDlg, IDC_EofChar, tmpstr);

  //------------------ evtchar
  wsprintf(tmpstr,"%u",(BYTE) dcb->EvtChar);
  SetDlgItemText(hDlg, IDC_EvtChar, tmpstr);

  //------------ Win32 special
  EnableWindow(GetDlgItem(hDlg, IDC_fBinary),0);
  EnableWindow(GetDlgItem(hDlg, IDC_fPeChar),0);
  EnableWindow(GetDlgItem(hDlg, IDC_fChEvt),0);
  EnableWindow(GetDlgItem(hDlg, IDC_PeChar),0);
  EnableWindow(GetDlgItem(hDlg, IDC_TxDelay),0);
  //------------------ DSR Sensitivity
  SendDlgItemMessage(hDlg, IDC_fDsrSensitivity, BM_SETCHECK, dcb->fDsrSensitivity, 0);

  //------------------ Continue TX when Xoff sent
  SendDlgItemMessage(hDlg, IDC_fTXContinueOnXoff, BM_SETCHECK, dcb->fTXContinueOnXoff, 0);

  //------------------ Enable Err Replacement
  SendDlgItemMessage(hDlg, IDC_fErrorChar, BM_SETCHECK, dcb->fErrorChar, 0);

  //------------------ Abort all reads and writes on Error
  SendDlgItemMessage(hDlg, IDC_fAbortOnError, BM_SETCHECK, dcb->fAbortOnError, 0);

  //------------------ Error replacement char
  wsprintf(tmpstr,"%u",(BYTE) dcb->ErrorChar);
  SetDlgItemText(hDlg, IDC_ErrorChar, tmpstr);\

}

/*-----------------------------------------------------------------------------
| misc_dlg_proc - Port Options dialog screen.
|  Misc DCB fields.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL misc_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
      GetMiscDlgInfo(hDlg);
    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:

          SetMiscDlgInfo(hDlg);
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDB_HELP:
          WinHelp(hDlg,"WCOM.HLP",HELP_INDEX,0L);
        break;

      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-------------------------------------------------------------------
| SetPortDlgInfo - Port Options Dialog, setup field values.
|--------------------------------------------------------------------*/
static void SetPortDlgInfo(HWND hDlg)
{

 unsigned long num;
 int j, stat;
 DCB *dcb = &glob_dlg_wcom->dcb;

  //------------------ baud
  j = (int)SendDlgItemMessage(hDlg, IDC_BAUD, CB_GETCURSEL, 0, 0L);
  if (GetDlgItemNumb(hDlg, IDC_BAUD, &num) == 0)
    dcb->BaudRate = (UINT) num;

  //------------------ bytes size
  if (GetDlgItemNumb(hDlg, IDC_BYTESIZE, &num) == 0)
    dcb->ByteSize = (BYTE) num;

#ifdef WIN32
  stat = SetCommState(glob_dlg_wcom->com_id,dcb);
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
#else
  stat = SetCommState(dcb);
#endif
  if (stat != 0)
    im_mess1("Error from SetCommState A2:",stat,"ByteSize:",dcb->ByteSize);

  //------------------ stop-bits
  j = (int)SendDlgItemMessage(hDlg, IDC_STOPBITSCB, CB_GETCURSEL, 0, 0L);
  dcb->StopBits = (BYTE) j;

  //------------------ parity
  j = (int)SendDlgItemMessage(hDlg, IDC_PARITYCB, CB_GETCURSEL, 0, 0L);
  dcb->Parity = j;
  dcb->fParity = IsDlgButtonChecked( hDlg, IDC_PARITY_EN);


  //------------------ rts ctrl
  j = (int)SendDlgItemMessage(hDlg, IDC_RTS, CB_GETCURSEL, 0, 0L);
#ifdef WIN32
  dcb->fRtsControl = j;
#else
  dcb->fRtsDisable = 0;
  dcb->fRtsflow = 0;
  if      (j==0) dcb->fRtsDisable = 1;
  else if (j==2) dcb->fRtsflow = 1;
#endif
  switch(j)  // keep track of output pins as best we can
  {
    case 0: glob_dlg_wcom->mcr_status &= ~MY_RTS; break;
    case 1: glob_dlg_wcom->mcr_status |= MY_RTS; break;
    case 2: glob_dlg_wcom->mcr_status |= MY_RTS; break;
    case 3: glob_dlg_wcom->mcr_status |= MY_RTS; break;
  }

  //------------------ dtr ctrl
  j = (int)SendDlgItemMessage(hDlg, IDC_DTR, CB_GETCURSEL, 0, 0L);
#ifdef WIN32
  dcb->fDtrControl = j;
#else
  dcb->fDtrDisable = 0;
  dcb->fDtrflow = 0;
  if      (j==0) dcb->fDtrDisable = 1;
  else if (j==2) dcb->fDtrflow = 1;
#endif
  switch(j)  // keep track of output pins as best we can
  {
    case 0: glob_dlg_wcom->mcr_status &= ~MY_DTR; break;
    case 1: glob_dlg_wcom->mcr_status |= MY_DTR; break;
    case 2: glob_dlg_wcom->mcr_status |= MY_DTR; break;
  }

  //------------------ xon-xoff out, in
  dcb->fOutX = IsDlgButtonChecked( hDlg, IDC_XONXOFF_OUT);
  dcb->fInX  = IsDlgButtonChecked( hDlg, IDC_XONXOFF_IN);

  //------------------ cts, dsr
  dcb->fOutxCtsFlow = IsDlgButtonChecked( hDlg, IDC_CTS);
  dcb->fOutxDsrFlow = IsDlgButtonChecked( hDlg, IDC_DSR);

#ifdef WIN32
  stat = SetCommState(glob_dlg_wcom->com_id,dcb);
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
#else
  stat = SetCommState(dcb);
#endif
  if (stat != 0)
    im_mess1("Error from SetCommState:",stat,0,0);
}

/*-------------------------------------------------------------------
| GetPortDlgInfo - Port Options Dialog, setup field values.
|--------------------------------------------------------------------*/
static void GetPortDlgInfo(HWND hDlg)
{
 HWND hwnd;
 char tmpstr[80];
 int j;
 int stat;
 DCB *dcb = &glob_dlg_wcom->dcb;

                             // read in the current port settings
  stat = GetCommState(glob_dlg_wcom->com_id, dcb);
#ifdef WIN32
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
#endif
  if (stat != 0)
    im_mess1("Error from GetCommState:",stat,0,0);


  //------------------ fill in baud rate cb
  wsprintf(tmpstr,"%u",dcb->BaudRate);
  SetDlgItemText(hDlg, IDC_BAUD, tmpstr);

  //------------------ fill in data bits cb
  wsprintf(tmpstr,"%u",dcb->ByteSize);
  SetDlgItemText(hDlg, IDC_BYTESIZE, tmpstr);

 //------------------ fill in parity cb
  hwnd = GetDlgItem(hDlg, IDC_PARITYCB);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "None");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Odd");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Even");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Mark");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Space");
  SendMessage(hwnd, CB_SETCURSEL, dcb->Parity, (LPARAM)0);

  SendDlgItemMessage(hDlg, IDC_PARITY_EN, BM_SETCHECK, dcb->fParity, 0);

  //------------------ fill in stop bits
  hwnd = GetDlgItem(hDlg, IDC_STOPBITSCB);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "1");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "1.5");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "2");

  SendMessage(hwnd, CB_SETCURSEL, dcb->StopBits, (LPARAM)0);

  //------------------ fill in rts
  hwnd = GetDlgItem(hDlg, IDC_RTS);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Clear");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Set");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Auto");
#ifdef WIN32
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Toggle");
  switch(dcb->fRtsControl)
  {
    case RTS_CONTROL_DISABLE:   j=0; break;
    case RTS_CONTROL_ENABLE:    j=1; break;
    case RTS_CONTROL_HANDSHAKE: j=2; break;
    case RTS_CONTROL_TOGGLE:    j=3; break;
  }
#else
  if (dcb->fRtsflow)          j = 2;
  else if (dcb->fRtsDisable)  j = 0;
  else                        j = 1;
#endif

  switch(j)  // keep track of output pins as best we can
  {
    case 0: glob_dlg_wcom->mcr_status &= ~MY_RTS; break;
    case 1: glob_dlg_wcom->mcr_status |= MY_RTS; break;
    case 2: glob_dlg_wcom->mcr_status |= MY_RTS; break;
    case 3: glob_dlg_wcom->mcr_status |= MY_RTS; break;
  }
  SendMessage(hwnd, CB_SETCURSEL, j, (LPARAM)0);

  //------------------ fill in dtr
  hwnd = GetDlgItem(hDlg, IDC_DTR);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Clear");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Set");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Auto");
#ifdef WIN32
  j = dcb->fDtrControl;
  switch(dcb->fDtrControl)
  {
    case DTR_CONTROL_DISABLE:    j=0; break;
    case DTR_CONTROL_ENABLE:     j=1; break;
    case DTR_CONTROL_HANDSHAKE:  j=2; break;
  }
#else
  if (dcb->fDtrflow)          j = 2;
  else if (dcb->fDtrDisable)  j = 0;
  else                        j = 1;
#endif
  switch(j)  // keep track of output pins as best we can
  {
    case 0: glob_dlg_wcom->mcr_status &= ~MY_DTR; break;
    case 1: glob_dlg_wcom->mcr_status |= MY_DTR; break;
    case 2: glob_dlg_wcom->mcr_status |= MY_DTR; break;
  }
  SendMessage(hwnd, CB_SETCURSEL, j, (LPARAM)0);

  //------------------ fill in xon/xoff
  SendDlgItemMessage(hDlg, IDC_XONXOFF_OUT, BM_SETCHECK, dcb->fOutX, 0);
  SendDlgItemMessage(hDlg, IDC_XONXOFF_IN, BM_SETCHECK, dcb->fInX, 0);

  //------------------ fill in cts, dsr
  SendDlgItemMessage(hDlg, IDC_CTS, BM_SETCHECK, dcb->fOutxCtsFlow, 0);
  SendDlgItemMessage(hDlg, IDC_DSR, BM_SETCHECK, dcb->fOutxDsrFlow, 0);


//  SendDlgItemMessage(hDlg, IDC_DISPLAYERRORS, BM_SETCHECK, dlg_set.derrors, 0);
}

/*-----------------------------------------------------------------------------
| options_dlg_proc - Port Options dialog screen.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL options_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
      GetPortDlgInfo(hDlg);
    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:

          SetPortDlgInfo(hDlg);
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDB_HELP:
          WinHelp(hDlg,"WCOM.HLP",HELP_INDEX,0L);
        break;
      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-----------------------------------------------------------------------------
| init_events_buttons -
|-----------------------------------------------------------------------------*/
void init_events_buttons(HWND hDlg,
#ifdef WIN32
                         DWORD ev,
#else
                         WORD ev,
#endif
                         int rec_cnt, int send_cnt)
{

  SendDlgItemMessage(hDlg, IDC_EV_RXCHAR, BM_SETCHECK, ev & EV_RXCHAR, 0);
  SendDlgItemMessage(hDlg, IDC_EV_RXFLAG, BM_SETCHECK, ev & EV_RXFLAG, 0);
  SendDlgItemMessage(hDlg, IDC_EV_TXEMPTY, BM_SETCHECK, ev & EV_TXEMPTY, 0);
  SendDlgItemMessage(hDlg, IDC_EV_CTS, BM_SETCHECK, ev & EV_CTS, 0);
  SendDlgItemMessage(hDlg, IDC_EV_DSR, BM_SETCHECK, ev & EV_DSR, 0);
  SendDlgItemMessage(hDlg, IDC_EV_RLSD, BM_SETCHECK, ev & EV_RLSD, 0);
  SendDlgItemMessage(hDlg, IDC_EV_BREAK, BM_SETCHECK, ev & EV_BREAK, 0);
  SendDlgItemMessage(hDlg, IDC_EV_ERR, BM_SETCHECK, ev & EV_ERR, 0);
  SendDlgItemMessage(hDlg, IDC_EV_RING, BM_SETCHECK, ev & EV_RING, 0);
  SendDlgItemMessage(hDlg, IDC_EV_PERR, BM_SETCHECK, ev & EV_PERR, 0);
#ifdef WIN32
  EnableWindow(GetDlgItem(hDlg, IDC_EV_CTSS),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_DSRS),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_RLSDS),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_RingTe),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_REC_CNT),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_SEND_CNT),0);
  SendDlgItemMessage(hDlg, IDC_EV_RX80FULL, BM_SETCHECK, ev & EV_RX80FULL, 0);
  SendDlgItemMessage(hDlg, IDC_EV_EVENT1, BM_SETCHECK, ev & EV_EVENT1, 0);
  SendDlgItemMessage(hDlg, IDC_EV_EVENT2, BM_SETCHECK, ev & EV_EVENT2, 0);
#else
  EnableWindow(GetDlgItem(hDlg, IDC_EV_RX80FULL),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_EVENT1),0);
  EnableWindow(GetDlgItem(hDlg, IDC_EV_EVENT2),0);
  SendDlgItemMessage(hDlg, IDC_EV_CTSS, BM_SETCHECK, ev & EV_CTSS, 0);
  SendDlgItemMessage(hDlg, IDC_EV_DSRS, BM_SETCHECK, ev & EV_DSRS, 0);
  SendDlgItemMessage(hDlg, IDC_EV_RLSDS, BM_SETCHECK, ev & EV_RLSDS, 0);
  SendDlgItemMessage(hDlg, IDC_EV_RingTe, BM_SETCHECK, ev & EV_RingTe, 0);
  {
    char tmpstr[20];
    wsprintf(tmpstr,"%d",rec_cnt);
    SetDlgItemText(hDlg, IDC_EV_REC_CNT, tmpstr);

    wsprintf(tmpstr,"%d",send_cnt);
    SetDlgItemText(hDlg, IDC_EV_SEND_CNT, tmpstr);
  }

#endif
}

/*-----------------------------------------------------------------------------
| events_dlg_proc - Port Options dialog screen.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL events_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
 char tmpstr[40];
 WORD uCmd;

#ifdef WIN32
 static COMMTIMEOUTS tm;
 static DWORD ev;
#else
 static WORD ev;
 unsigned long num;
#endif
 static int rec_cnt, send_cnt;

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
      ev = glob_dlg_wcom->event_mask;
      rec_cnt = glob_dlg_wcom->ev_rec_cnt;
      send_cnt = glob_dlg_wcom->ev_send_cnt;
      if (ev > 0)
           SetDlgItemText(hDlg, IDC_EV_ALL, "All Off");
      else SetDlgItemText(hDlg, IDC_EV_ALL, "All On");
      init_events_buttons(hDlg, ev, rec_cnt, send_cnt);
    return 0;

    case WM_COMMAND:
#ifdef WIN32
      uCmd = HIWORD(wParam);
#else
      uCmd = HIWORD(lParam);
#endif
      switch (LOWORD(wParam))
      {
        case IDC_EV_ALL:
          if (uCmd != BN_CLICKED) break;
          GetDlgItemText(hDlg, IDC_EV_ALL, tmpstr, 18);
          if (tmpstr[5] == 'n')
          {
            SetDlgItemText(hDlg, IDC_EV_ALL, "All Off");
            ev = 
               (EV_RXCHAR | EV_RXFLAG | EV_TXEMPTY | EV_CTS  | EV_DSR  |
                EV_RLSD   | EV_BREAK  | EV_ERR     | EV_RING | EV_PERR |
#ifdef WIN32
                EV_RX80FULL | EV_EVENT1 | EV_EVENT2);
#else
                EV_CTSS | EV_DSRS | EV_RLSDS | EV_RingTe);
#endif

            if (rec_cnt < 0) rec_cnt = 1;
            if (send_cnt < 0) send_cnt = 1;
            init_events_buttons(hDlg, ev, rec_cnt, send_cnt);
          }
          else
          {
            SetDlgItemText(hDlg, IDC_EV_ALL, "All On");
            ev = 0;
            rec_cnt = -1;
            send_cnt = -1;
            init_events_buttons(hDlg, ev, rec_cnt, send_cnt);
          }
        break;

        case IDOK:
  if (IsDlgButtonChecked( hDlg, IDC_EV_RXCHAR))
    ev |= EV_RXCHAR; else ev &= ~EV_RXCHAR;

  if (IsDlgButtonChecked( hDlg, IDC_EV_RXFLAG))
    ev |= EV_RXFLAG; else ev &= ~EV_RXFLAG;

  if (IsDlgButtonChecked( hDlg, IDC_EV_TXEMPTY))
    ev |= EV_TXEMPTY; else ev &= ~EV_TXEMPTY;

  if (IsDlgButtonChecked( hDlg, IDC_EV_CTS))
    ev |= EV_CTS; else ev &= ~EV_CTS;

  if (IsDlgButtonChecked( hDlg, IDC_EV_DSR))
    ev |= EV_DSR; else ev &= ~EV_DSR;

  if (IsDlgButtonChecked( hDlg, IDC_EV_RLSD))
    ev |= EV_RLSD; else ev &= ~EV_RLSD;

  if (IsDlgButtonChecked( hDlg, IDC_EV_BREAK))
    ev |= EV_BREAK; else ev &= ~EV_BREAK;

  if (IsDlgButtonChecked( hDlg, IDC_EV_ERR))
    ev |= EV_ERR; else ev &= ~EV_ERR;

  if (IsDlgButtonChecked( hDlg, IDC_EV_RING))
    ev |= EV_RING; else ev &= ~EV_RING;

  if (IsDlgButtonChecked( hDlg, IDC_EV_PERR))
    ev |= EV_PERR; else ev &= ~EV_PERR;

#ifdef WIN32
  if (IsDlgButtonChecked( hDlg, IDC_EV_RX80FULL))
    ev |= EV_RX80FULL; else ev &= ~EV_RX80FULL;

  if (IsDlgButtonChecked( hDlg, IDC_EV_EVENT1))
    ev |= EV_EVENT1; else ev &= ~EV_EVENT1;

  if (IsDlgButtonChecked( hDlg, IDC_EV_EVENT2))
    ev |= EV_EVENT2; else ev &= ~EV_EVENT2;
#else
  if (IsDlgButtonChecked( hDlg, IDC_EV_CTSS))
    ev |= EV_CTSS; else ev &= ~EV_CTSS;

  if (IsDlgButtonChecked( hDlg, IDC_EV_DSRS))
    ev |= EV_DSRS; else ev &= ~EV_DSRS;

  if (IsDlgButtonChecked( hDlg, IDC_EV_RLSDS))
    ev |= EV_RLSDS; else ev &= ~EV_RLSDS;

  if (IsDlgButtonChecked( hDlg, IDC_EV_RingTe))
    ev |= EV_RingTe; else ev &= ~EV_RingTe;

  if (GetDlgItemNumb(hDlg, IDC_EV_REC_CNT, &num) == 0)
    glob_dlg_wcom->ev_rec_cnt = (int) num;

  if (GetDlgItemNumb(hDlg, IDC_EV_SEND_CNT, &num) == 0)
    glob_dlg_wcom->ev_send_cnt = (int) num;
#endif
          glob_dlg_wcom->event_mask = ev;

#ifdef WIN32
        SetCommMask(glob_dlg_wcom->com_id, glob_dlg_wcom->event_mask);
#else
        glob_dlg_wcom->event_ptr = SetCommEventMask(glob_dlg_wcom->com_id,
                                                glob_dlg_wcom->event_mask);
        if (glob_dlg_wcom->event_ptr == NULL)
          glob_dlg_wcom->ttywin.mess_str("<SetCommEventMask Error:EVENT_PTR NULL>");

        if (EnableCommNotification(glob_dlg_wcom->com_id,
                               glob_dlg_wcom->hwnd,
                               glob_dlg_wcom->ev_rec_cnt,
                               glob_dlg_wcom->ev_send_cnt) == FALSE)
        {
          im_mess1("Error from EnableCommNotification",0,0,0);
        }

        // need to clear out any previous events to get more
        GetCommEventMask(glob_dlg_wcom->com_id, glob_dlg_wcom->event_mask);
#endif
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;
      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-----------------------------------------------------------------------------
| timeouts_dlg_proc - Port Options dialog screen.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL timeouts_dlg_proc(HWND hDlg,
                         UINT message,
                         WPARAM wParam,
                         LPARAM lParam)
{
 unsigned long num;
 char tmpstr[40];
#ifdef WIN32
 static COMMTIMEOUTS tm;
#else
 DCB *dcb = &glob_dlg_wcom->dcb;
 int stat;
#endif

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */

#ifdef WIN32
  EnableWindow(GetDlgItem(hDlg, IDC_CTS_TIMEOUT),0);
  EnableWindow(GetDlgItem(hDlg, IDC_DSR_TIMEOUT),0);
  EnableWindow(GetDlgItem(hDlg, IDC_RLS_TIMEOUT),0);

  GetCommTimeouts(glob_dlg_wcom->com_id,&tm);
  wsprintf(tmpstr,"%u",tm.ReadIntervalTimeout);
  SetDlgItemText(hDlg, IDC_RIT, tmpstr);

  wsprintf(tmpstr,"%u",tm.ReadTotalTimeoutMultiplier);
  SetDlgItemText(hDlg, IDC_RTTM, tmpstr);

  wsprintf(tmpstr,"%u",tm.ReadTotalTimeoutConstant);
  SetDlgItemText(hDlg, IDC_RTTC, tmpstr);

  wsprintf(tmpstr,"%u",tm.WriteTotalTimeoutMultiplier);
  SetDlgItemText(hDlg, IDC_WTTM, tmpstr);

  wsprintf(tmpstr,"%u",tm.WriteTotalTimeoutConstant);
  SetDlgItemText(hDlg, IDC_WTTC, tmpstr);
#else //------------------ fill in timeouts, 16-bit
                             // read in the current port settings
  EnableWindow(GetDlgItem(hDlg, IDC_RIT),0);
  EnableWindow(GetDlgItem(hDlg, IDC_RTTM),0);
  EnableWindow(GetDlgItem(hDlg, IDC_RTTC),0);
  EnableWindow(GetDlgItem(hDlg, IDC_WTTM),0);
  EnableWindow(GetDlgItem(hDlg, IDC_WTTC),0);

                             // read in the current port settings
  stat = GetCommState(glob_dlg_wcom->com_id, dcb);
  if (stat != 0)
    im_mess1("Error from GetCommState:",stat,0,0);

  wsprintf(tmpstr,"%u",dcb->CtsTimeout);
  SetDlgItemText(hDlg, IDC_CTS_TIMEOUT, tmpstr);

  wsprintf(tmpstr,"%u",dcb->DsrTimeout);
  SetDlgItemText(hDlg, IDC_DSR_TIMEOUT, tmpstr);

  wsprintf(tmpstr,"%u",dcb->RlsTimeout);
  SetDlgItemText(hDlg, IDC_RLS_TIMEOUT, tmpstr);
#endif

    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:

#ifdef WIN32
  if (GetDlgItemNumb(hDlg, IDC_RIT, &num) == 0)
    tm.ReadIntervalTimeout = num;

  if (GetDlgItemNumb(hDlg, IDC_RTTM, &num) == 0)
    tm.ReadTotalTimeoutMultiplier = num;

  if (GetDlgItemNumb(hDlg, IDC_RTTC, &num) == 0)
    tm.ReadTotalTimeoutConstant = num;

  if (GetDlgItemNumb(hDlg, IDC_WTTM, &num) == 0)
    tm.WriteTotalTimeoutMultiplier = num;

  if (GetDlgItemNumb(hDlg, IDC_WTTC, &num) == 0)
    tm.WriteTotalTimeoutConstant = num;

    SetCommTimeouts(glob_dlg_wcom->com_id,&tm);

#else //------------------ fill in timeouts, 16-bit
  if (GetDlgItemNumb(hDlg, IDC_CTS_TIMEOUT, &num) == 0)
    dcb->CtsTimeout = (UINT) num;

  if (GetDlgItemNumb(hDlg, IDC_DSR_TIMEOUT, &num) == 0)
    dcb->DsrTimeout = (UINT) num;

  if (GetDlgItemNumb(hDlg, IDC_RLS_TIMEOUT, &num) == 0)
    dcb->RlsTimeout = (UINT) num;

  stat = SetCommState(dcb);
  if (stat != 0)
    im_mess1("Error from SetCommState:",stat,0,0);
#endif

          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDB_HELP:
          WinHelp(hDlg,"WCOM.HLP",HELP_INDEX,0L);
        break;

      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-----------------------------------------------------------------------------
| GetDlgItemNumb - get a number from the text dialog field
|-----------------------------------------------------------------------------*/
static int GetDlgItemNumb(HWND hDlg, int ctrl, unsigned long *num)
{
 char tmpstr[40];
 int i;


  GetDlgItemText(hDlg, ctrl, tmpstr, 18);
  i = 0;
  while (tmpstr[i] == ' ')
    ++i;
         // look for leading 0x for hex numbers
  if ((tmpstr[i] == '0') && (toupper(tmpstr[i+1]) == 'X'))
  {
    i+=2;
    if (sscanf(&tmpstr[i],"%lx",num) == 1)
      return 0;
    return 1;
  }

         // look for trailing 'H' for hex numbers
  i = strlen(tmpstr);
  if (i>0) --i;
  while ((tmpstr[i] == ' ') && (i != 0))
    --i;
  if ((toupper(tmpstr[i])) == 'H')
  {
    if (sscanf(tmpstr,"%lx",num) == 1)
      return 0;
    return 1;
  }

        // normal decimal case
  if (sscanf(tmpstr,"%ld",num) == 1)
    return 0;  // ok

  if (tmpstr[0] != 0)  // allow ascii to dec conversion case
    *num = tmpstr[0];
  return 0;  // ok
}

/*-----------------------------------------------------------------------------
| portname_dlg_proc - type in the port name.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL portname_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
      SetDlgItemText(hDlg, IDC_PORTNAME, "");
    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:
          GetDlgItemText(hDlg, IDC_PORTNAME, pickportname,38);
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          pickportname[0] = 0;
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;
      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-------------------------------------------------------------------
| SetSettingsDlgInfo - Port Options Dialog, setup field values.
|--------------------------------------------------------------------*/
static void SetSettingsDlgInfo(HWND hDlg)
{

 int j, stat;
 DCB *dcb = &glob_dlg_wcom->dcb;
 char tmpstr[60];
 DWORD val;

  //------------------ baud
  GetDlgItemText(hDlg, IDC_BAUD, tmpstr, 58);
  stat= sscanf(tmpstr,"%ld",&val);
  if ((stat == 1) && (val >= 0))
    dcb->BaudRate = (UINT) val;

  //------------------ bytes size
  GetDlgItemText(hDlg, IDC_BYTESIZE, tmpstr, 58);
  stat= sscanf(tmpstr,"%ld",&val);
  if ((stat == 1) && (val >= 0))
    dcb->ByteSize = (BYTE) val;

  //------------------ stop-bits
  j = (int)SendDlgItemMessage(hDlg, IDC_STOPBITSCB, CB_GETCURSEL, 0, 0L);
  dcb->StopBits = (BYTE) j;

  //------------------ parity
  j = (int)SendDlgItemMessage(hDlg, IDC_PARITYCB, CB_GETCURSEL, 0, 0L);
  dcb->Parity = j;
  if (dcb->Parity != 0)
    dcb->fParity = 1;

  //------------------ rts ctrl
#ifdef WIN32
  dcb->fOutX = 0;
  dcb->fInX  = 0;
  dcb->fRtsControl = RTS_CONTROL_ENABLE;
  dcb->fDtrControl = DTR_CONTROL_ENABLE;
#else
  dcb->fDtrflow = 0;
  dcb->fDtrDisable = 0;
  dcb->fRtsflow = 0;
  dcb->fRtsDisable = 0;
#endif
  dcb->fOutxCtsFlow = 0;
  dcb->fOutxDsrFlow = 0;

  j = (int)SendDlgItemMessage(hDlg, IDC_FLOW, CB_GETCURSEL, 0, 0L);
  switch(j)
  {
    case 0:  // none
    break;
    case 1:  // hardware
#ifdef WIN32
      dcb->fRtsControl = RTS_CONTROL_HANDSHAKE;
#else
      dcb->fRtsflow = 1;
#endif
      dcb->fOutxCtsFlow = 1;
    break;
    case 2:  // xon-xoff
      dcb->fOutX = 1;
      dcb->fInX  = 1;
    break;
  }

#ifdef WIN32
  stat = SetCommState(glob_dlg_wcom->com_id,dcb);
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
#else
  stat = SetCommState(dcb);
#endif
  if (stat != 0)
    im_mess1("Error from SetCommState:",stat,0,0);
}

/*-------------------------------------------------------------------
| GetSettingsDlgInfo - Port Options Dialog, setup field values.
|--------------------------------------------------------------------*/
static void GetSettingsDlgInfo(HWND hDlg)
{
 HWND hwnd;
 char tmpstr[80];
 int j, found;
 int stat;
 DCB *dcb = &glob_dlg_wcom->dcb;
 static DWORD bauds[] = {300,600,1200,2400,3600,4800,7200,9600,19200,
                         38400, 57600, 115200, 230400, 460800, 921600, 0};

                             // read in the current port settings
  stat = GetCommState(glob_dlg_wcom->com_id, dcb);
#ifdef WIN32
  if (stat == TRUE) stat = 0;
  else stat = GetLastError();
#endif
  if (stat != 0)
    im_mess1("Error from GetCommState:",stat,0,0);


  //------------------ fill in baud rate cb
  hwnd = GetDlgItem(hDlg, IDC_BAUD);
  j=0;
  found = 0;
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  while (bauds[j] != 0)
  {
    if (dcb->BaudRate == bauds[j])
      found = j;
    wsprintf(tmpstr,"%u",bauds[j++]);
    SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) tmpstr);
  }
  SendMessage(hwnd, CB_SETCURSEL, found, (LPARAM)0);

  //------------------ fill in data bits cb
  hwnd = GetDlgItem(hDlg, IDC_BYTESIZE);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "7 bits");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "8 bits");
  if (dcb->ByteSize == 7)
       SendMessage(hwnd, CB_SETCURSEL, 0, (LPARAM)0);
  else SendMessage(hwnd, CB_SETCURSEL, 1, (LPARAM)0);

 //------------------ fill in parity cb
  hwnd = GetDlgItem(hDlg, IDC_PARITYCB);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "None");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Odd");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Even");
  SendMessage(hwnd, CB_SETCURSEL, dcb->Parity, (LPARAM)0);

  //------------------ fill in stop bits
  hwnd = GetDlgItem(hDlg, IDC_STOPBITSCB);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "1");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "1.5");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "2");
  SendMessage(hwnd, CB_SETCURSEL, dcb->StopBits, (LPARAM)0);

  //------------------ fill in flow
  hwnd = GetDlgItem(hDlg, IDC_FLOW);
  SendMessage(hwnd, CB_RESETCONTENT, 0, 0);
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "None");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Hardware");
  SendMessage(hwnd, CB_ADDSTRING, 0, (LPARAM) "Xon/Xoff");

  found = 0;
  if (dcb->fOutX != 0)
    found = 2;
#ifdef WIN32
  if (dcb->fRtsControl == RTS_CONTROL_HANDSHAKE)
    found = 1;
#else
  if (dcb->fRtsflow)
    found = 1;
#endif
  SendMessage(hwnd, CB_SETCURSEL, found, (LPARAM)0);
}

/*-----------------------------------------------------------------------------
| settings_dlg_proc - Port Options dialog screen.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL settings_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
      GetSettingsDlgInfo(hDlg);
    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:

          SetSettingsDlgInfo(hDlg);
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDB_HELP:
          WinHelp(hDlg,"WCOM.HLP",HELP_INDEX,0L);
        break;

      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

/*-----------------------------------------------------------------------------
| qsizes_dlg_proc - Queue Size dlg.
|-----------------------------------------------------------------------------*/
BOOL FAR PASCAL qsizes_dlg_proc(HWND hDlg, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
#ifndef WIN32
typedef struct COMMPROP {
  WORD dwCurrentRxQueue;
  WORD dwCurrentTxQueue;
};
#endif

 static COMMPROP our_commprop;
 int stat;
 unsigned long num;
 char tmpstr[40];

  switch (message)
  {
    case WM_INITDIALOG:     /* message: initialize dialog box */
#ifdef WIN32
      stat = GetCommProperties(glob_wcom->com_id, &our_commprop);
#endif
      wsprintf(tmpstr,"%u", our_commprop.dwCurrentRxQueue);
      SetDlgItemText(hDlg, IDC_IN_QSIZE, tmpstr);

      wsprintf(tmpstr,"%u", our_commprop.dwCurrentTxQueue);
      SetDlgItemText(hDlg, IDC_OUT_QSIZE, tmpstr);

      // this turns off reading/writing from port while dialog is up,
      // for a way to test flow control by halting the read down of
      // the buffer.  Putting it in this dialog is arbitrary.
      glob_wcom->testing_flag = 1;

    return 0;

    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case IDOK:
          if (GetDlgItemNumb(hDlg, IDC_IN_QSIZE, &num) == 0)
            our_commprop.dwCurrentRxQueue = num;

          if (GetDlgItemNumb(hDlg, IDC_OUT_QSIZE, &num) == 0)
            our_commprop.dwCurrentTxQueue = num;

          stat = SetupComm(glob_wcom->com_id,
                         our_commprop.dwCurrentRxQueue,
                         our_commprop.dwCurrentTxQueue);
          if (stat != TRUE)
          {
           stat = GetLastError();
           im_mess1("Error from SetupComm:",stat,NULL,0);
          }
          glob_wcom->testing_flag = 0;
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDCANCEL:
          glob_wcom->testing_flag = 0;
          EndDialog(hDlg, NULL);       /* Exits the dialog box      */
        break;

        case IDB_HELP:
          WinHelp(hDlg,"WCOM.HLP",HELP_INDEX,0L);
        break;

      }
    break;
  }
  return (FALSE);         /* Didn't process a message    */
}

